# 《HelloGitHub》第 23 期
> 兴趣是最好的老师，**HelloGitHub** 让你对开源感兴趣！
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/cover.jpg' style="max-width:100%;"></img>
</p>

## 目录

点击右上角的 **「目录」** 图标打开目录，获得更好的阅读体验。

![](https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/catalog.png)

**Tips**：如果遇到图片刷不出来的情况，[点击](https://hellogithub.com/periodical/volume/23) 换一种浏览方式。

<p align="center">
  <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/weixin.png" style="max-width:30%;"></img><br>
关注「HelloGitHub」公众号，第一时间收到推送
</p>

## 内容
> **以下为本期内容**｜每个月 **28** 号更新

### C 项目
1、[ffmpeg-libav-tutorial](https://hellogithub.com/periodical/statistics/click?target=https://github.com/leandromoreira/ffmpeg-libav-tutorial)：《笨方法学 FFmpeg libav》（英文）


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/109762904.png' style="max-width:80%; max-height=80%;"></img></p>

### Java 项目
2、[CC](https://hellogithub.com/periodical/statistics/click?target=https://github.com/luckybilly/CC)：使用简单、功能丰富的 Android 组件化框架。适用于几乎所有的组件化开发需求，可进行组件层面的 AOP 编程。[项目 wiki](https://github.com/luckybilly/CC/wiki)


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/111830550.gif' style="max-width:80%; max-height=80%;"></img></p>

3、[WxJava](https://hellogithub.com/periodical/statistics/click?target=https://github.com/binarywang/WxJava)：开源、非官方、功能全面的微信开发 Java SDK，支持包括微信支付、开放平台、小程序、企业号和公众号等功能的开发。[示例 Demo 索引](https://github.com/Wechat-Group/weixin-java-tools/blob/master/demo.md)，以及详细的[开发文档](https://github.com/wechat-group/weixin-java-tools/wiki)


### JavaScript 项目
4、[node-fetch](https://hellogithub.com/periodical/statistics/click?target=https://github.com/node-fetch/node-fetch)：将 fetch 引入了 node 环境，配合了 node 强大的 http 模块。做到了在不同的 JS 环境中使用一致的API。fetch API 是代替 XMLHttpRequest 的一种全新的解决方案，其简化了 XHR 的复杂步骤，采用了 Promise。示例代码如下：
```javascript
fetch('/url').then(res => {}).catch(err => {})
```


5、[prettier](https://hellogithub.com/periodical/statistics/click?target=https://github.com/prettier/prettier)：十分方便的代码格式化库。支持如：JavaScript、Flow、TypeScript、CSS、SCSS等编程语言。同时提供了编辑插件，在使用 vscode 开发 Vue 项目时候，使用此插件可以让代码更具有可读性
```javascript
/**
 * 格式化之前
 */
foo(reallyLongArg(), omgSoManyParameters(), IShouldRefactorThis(), isThereSeriouslyAnotherOne());

/**
 * 格式化之后
 */
foo(
  reallyLongArg(),
  omgSoManyParameters(),
  IShouldRefactorThis(),
  isThereSeriouslyAnotherOne()
);
```


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/75104123.png' style="max-width:80%; max-height=80%;"></img></p>

6、[wiki](https://hellogithub.com/periodical/statistics/click?target=https://github.com/requarks/wiki)：NodeJS+Git+Markdown 实现轻松搭建 wiki。对于团队内部的知识分享是一个不错的选择。[在线预览](https://docs.requarks.io/wiki)


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/65848095.png' style="max-width:80%; max-height=80%;"></img></p>

### Objective-C 项目
7、[iOS-Performance-Optimization](https://hellogithub.com/periodical/statistics/click?target=https://github.com/skyming/iOS-Performance-Optimization)：关于 iOS 性能优化梳理。包含基本工具、业务优化、内存优化、卡顿优化、布局优化、电量优化、 安装包瘦身、启动优化、网络优化等


### PHP 项目
8、[arithmetic-php](https://hellogithub.com/periodical/statistics/click?target=https://github.com/pushaowei/arithmetic-php)：PHP 语言实现的各类算法合集 


### Python 项目
9、[python-console-snake](https://hellogithub.com/periodical/statistics/click?target=https://github.com/tancredi/python-console-snake)：命令行贪吃蛇


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/13356681.png' style="max-width:80%; max-height=80%;"></img></p>

10、[redash](https://hellogithub.com/periodical/statistics/click?target=https://github.com/getredash/redash)：开源的数据可视化 Web 项目，提供了数据库查询和数据可视化功能。只提供的数据可视化最要的功能，使得简单易用且容易上手。可以直观地将一个 SQL 查询的结果可视化出来。同时提供 SQL 代码片段存储，减少重复编写 SQL 的问题


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/13926404.gif' style="max-width:80%; max-height=80%;"></img></p>

11、[rq](https://hellogithub.com/periodical/statistics/click?target=https://github.com/rq/rq)：基于 redis 的简单、轻量级任务队列库。可以帮助理解简单的任务队列模式和设计。使用简单、文档健全，适用于小型项目或简单的场景。
```shell
# Tip：job 需要通过模块引用加入到任务队列中
23:46:59 Cleaning registries for queue: default
23:47:47 default: snap1.count_words_at_url('https://hellogithub.com') (c4f96606-c833-4057-8ac4-b35bc60dfec9)
23:47:47 default: Job OK (c4f96606-c833-4057-8ac4-b35bc60dfec9)
23:47:47 Result is kept for 500 seconds
```


12、[toapi](https://hellogithub.com/periodical/statistics/click?target=https://github.com/elliotgao2/toapi)：该项目做的事儿是通过简单的配置把目标网页的内容爬下来，缓存结果后提供成 API 的一条龙服务。


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/112169994.png' style="max-width:80%; max-height=80%;"></img></p>

### Swift 项目
13、[LyricsX](https://hellogithub.com/periodical/statistics/click?target=https://github.com/ddddxxx/LyricsX)：一个为 iTunes、Spotify、Vox 播放器提供自动下载歌词，并在桌面和任务栏显示的插件


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/23/81710355.jpg' style="max-width:80%; max-height=80%;"></img></p>

### 人工智能
14、[captcha_break](https://hellogithub.com/periodical/statistics/click?target=https://github.com/ypwhs/captcha_break)：使用深度学习来破解 captcha（python 生成验证码的库）验证码。该项目会通过 Keras 搭建一个深度卷积神经网络来识别 captcha 生成的图片验证码，建议使用显卡来运行该项目。可视化代码都是在 jupyter notebook 中完成的，如果你希望写成 python 脚本，稍加修改即可正常运行


### 其它
15、[awesome-blockchain-cn](https://hellogithub.com/periodical/statistics/click?target=https://github.com/chaozh/awesome-blockchain-cn)：区块链技术开发相关资料


16、[Back-End-Developer-Interview-Questions](https://hellogithub.com/periodical/statistics/click?target=https://github.com/monklof/Back-End-Developer-Interview-Questions)：后端面试问题集合


17、[hangzhou_house_knowledge](https://hellogithub.com/periodical/statistics/click?target=https://github.com/houshanren/hangzhou_house_knowledge)：《杭州房产知识扫盲》，作者 2017 年总结出来的买房购房知识，希望可以帮助到要在杭州买房的朋友


18、[http-api-design](https://hellogithub.com/periodical/statistics/click?target=https://github.com/interagent/http-api-design)：HTTP API 设计指南。这篇指南介绍描述了 HTTP+JSON API 的一种设计模式，最初摘录整理自 Heroku 平台的 API 设计指南。[中文翻译版](https://github.com/ZhangBohan/http-api-design-ZH_CN)


19、[vim-galore](https://hellogithub.com/periodical/statistics/click?target=https://github.com/mhinz/vim-galore)：Vim 从入门到精通，[中文](https://github.com/wsdjeg/vim-galore-zh_cn)


### 开源书籍
20、[yast-cn](https://hellogithub.com/periodical/statistics/click?target=https://github.com/DeathKing/yast-cn)：《Scheme入门教程》中译版，[在线阅读](http://deathking.github.io/yast-cn/)




<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/HelloGitHub22.md">『上一期』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/899'>反馈和建议</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/HelloGitHub24.md">『下一期』</a>
</p>

---
<p align="center">
    👉 <a href='https://hellogithub.com/periodical'>来！推荐开源项目</a> 👈<br>
    微信中搜：<strong>HelloGitHub</strong> 关注公众号<br>
    不仅能第一时间收到推送，还有回馈粉丝的活动<br>
    如果文中的图刷不出来，可以点击 <a href='https://hellogithub.com/periodical/volume/23'>这里</a>。
</p>

## 赞助


<table>
  <thead>
    <tr>
      <th align="center" style="width: 80px;">
        <a href="https://www.compshare.cn/?utm_term=logo&utm_campaign=hellogithub&utm_source=otherdsp&utm_medium=display&ytag=logo_hellogithub_otherdsp_display">          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/ucloud.png" width="60px"><br>
          <sub>UCloud</sub><br>
          <sub>超值的GPU云服务</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.upyun.com/?from=hellogithub">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/upyun.png" width="60px"><br>
          <sub>CDN</sub><br>
          <sub>开启全网加速</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://github.com/OpenIMSDK/Open-IM-Server">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/im.png" width="60px"><br>
          <sub>OpenIM</sub><br>
          <sub>开源IM力争No.1</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.qiniu.com/products/ai-token-api?utm_source=hello">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/qiniu.jpg" width="60px"><br>
          <sub>七牛云</sub><br>
          <sub>百万 Token 免费体验</sub>
        </a>
      </th>
    </tr>
  </thead>
</table>


## 声明
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh"><img alt="知识共享许可协议" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>本作品采用 <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh">署名-非商业性使用-禁止演绎 4.0 国际</a> 进行许可。
