# HelloGitHub Vol.101
> Passion is the best teacher. **HelloGitHub** inspires your interest in open-source!
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/cover.jpg' style="max-width:100%;"></img>
</p>

## Table of Contents

Click the **「Table of Contents」** icon at the top-right corner to open the navigation and enjoy a better reading experience.

![](https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/catalog.png)

## Content
> **The content of this issue is as follows**｜Updated on the **28th** of each month

### C
1、[austin](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/P403n1x87/austin)：In-Depth Python Program Performance Analysis Tool. This is a performance analysis tool specifically designed for Python programs, capable of easily pinpointing performance bottlenecks and memory usage of Python programs without modifying the code. It is a CPython frame stack sampler written in C language, characterized by its small size, fast running speed, and zero code intrusion, supporting various visualization methods such as WebUI, TUI, and VSCode (additional installation required).

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/149680486.gif' style="max-width:80%; max-height=80%;"></img></p>

2、[chsrc](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/RubyMetric/chsrc)：Universal Multi-Platform Source Switching Tool. This project is capable of switching to domestic mirror sources for common Linux distributions, programming languages, and software with a simple one-command operation. Written in C, it features efficiency and a lightweight nature, offering functionalities such as speed testing, multi-platform support, and project-level source switching, suitable for optimizing download speeds or resolving source access issues.Shared by [@ccmywish](https://hellogithub.com/en/user/H6YVMUy7ulev8R4)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/686497147.png' style="max-width:80%; max-height=80%;"></img></p>

3、[collectd](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/collectd/collectd)：Flexible System Information Collection Daemon. This is a powerful daemon for collecting system information that can regularly gather and tally information about the system. It supports a rich array of data collection plugins capable of monitoring hardware usage, system performance metrics, network traffic, and various types of data, including Apache, MySQL, batteries, sensors, etc. It also supports outputting collected data to databases and monitoring systems such as RRDtool and InfluxDB, suitable for scenarios like embedded systems, IoT, and server cluster monitoring.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/3208640.png' style="max-width:80%; max-height=80%;"></img></p>

### C#
4、[LenovoLegionToolkit](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/BartoszCichecki/LenovoLegionToolkit)：Lightweight Legion Rescue Tool. This project is an open-source tool specifically designed for Lenovo Legion series laptops, featuring portability, low memory usage, and no user data collection. It supports the adjustment of power modes, graphics card working modes, fan speeds, and keyboard lighting effects, and provides a Chinese interface, serving as an open-source alternative to Lenovo Vantage software.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/418846673.png' style="max-width:80%; max-height=80%;"></img></p>

5、[PDFQFZ](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/flytkgl/PDFQFZ)：Free PDF Saddle Stitch Stamp Tool. This project is a tool for stamping saddle stitches on PDF files, which is applicable to the Windows platform. It is not only free and open-source but also allows users to specify directories for batch processing of multiple PDF files, and supports features such as previewing, adjusting the size and position of the stamp.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/128596963.jpg' style="max-width:80%; max-height=80%;"></img></p>

### C++
6、[lnav](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/tstack/lnav)：Powerful Terminal Log File Viewer. This is a lightweight tool for viewing and analyzing log files. It comes ready to use without any configuration, can automatically recognize log formats and decompress files, supports handling multiple files and directories simultaneously, real-time updates, text highlighting, and filtering logs with regular expressions and SQL, making it particularly suitable for use in server and development environments.Shared by [@DeShuiYu](https://hellogithub.com/en/user/ZWJkOqsvYbPgD8p)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/306147.png' style="max-width:80%; max-height=80%;"></img></p>

7、[shadPS4](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/shadps4-emu/shadPS4)：Open source PlayStation 4 (PS4) Emulator. This is a PlayStation 4 (PS4) emulator written in C++ that allows you to play PS4 games on Windows, Linux, and macOS systems. Although the project is still in its early stages of development, with a limited number of games supported, the latest version has successfully run games such as 'Bloodborne' and 'Dark Souls II'.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/556675672.png' style="max-width:80%; max-height=80%;"></img></p>

### Go
8、[doggo](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/mr-karan/doggo)：User-Friendly Command-Line DNS Query Tool. This project is a command-line DNS client tool written in Go language, which is simple to install and ready to use out of the box. It provides a user-friendly command-line interface to quickly display DNS record information, supports highlighting, response time, and various types of DNS records, suitable for network diagnostics and other scenarios.
```
# Simple DNS lookup
doggo example.com

# Query MX records using a specific nameserver
doggo MX github.com @9.9.9.9

# Use DNS over HTTPS
doggo example.com @https://cloudflare-dns.com/dns-query

# JSON output for scripting
doggo example.com --json | jq '.responses[0].answers[].address'

# Reverse DNS lookup
doggo --reverse 8.8.8.8 --short
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/319848237.png' style="max-width:80%; max-height=80%;"></img></p>

9、[glasskube](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/glasskube/glasskube)：Easier Kubernetes Package Manager. This is a Kubernetes package management tool that provides an intuitive graphical interface and flexible command-line tools. With simple operations and ease of use, it supports automatic dependency handling, GitOps, and automatic updates, simplifying the tedious manual configuration process.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/742106639.gif' style="max-width:80%; max-height=80%;"></img></p>

10、[lancet](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/duke-git/lancet)：Comprehensive Go Language Utility Functions Library. This is an efficient and comprehensive utility functions library for the Go language, including over 600 functions that cover features such as string processing, slice manipulation, network programming, concurrency, encryption and decryption, file handling, time/date handling, stream processing, and iterators.Shared by [@两双筷子sqldc](https://hellogithub.com/en/user/5dGtvaZ6H3L4QMY)
```go
package main

import (
    "fmt"
    "github.com/duke-git/lancet/v2/strutil"
)

func main() {
    s := "hello"
    rs := strutil.Reverse(s)
    fmt.Println(rs) //olleh
}
```

11、[neko](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/m1k1o/neko)：Versatile Virtual Browser Tool. This project is a self-hosted virtual browser environment running in a Docker container, offering users a secure, isolated, and fully-featured virtual browser. Additionally, it supports online sharing of the browser and real-time interactive demonstrations, featuring multi-user access, admin users, text chat, and bidirectional file transfer capabilities.Shared by [@猎隼丶止戈reNo7](https://hellogithub.com/en/user/Ew59HqRWjPe0zZO)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/247350713.gif' style="max-width:80%; max-height=80%;"></img></p>

12、[sftpgo](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/drakkan/sftpgo)：SFTP Server with Integrated Cloud Storage. This project is a fully featured, flexible, and configurable SFTP server written in Go, supporting multiple file transfer protocols such as SFTP, SCP, FTP/S, WebDAV, and HTTP/S. It is compatible with various storage backends including local file systems, S3, and Google Cloud Storage. Additionally, it provides a web interface for easy creation and management of users, folders, groups, and other resources.Shared by [@猎隼丶止戈reNo7](https://hellogithub.com/en/user/Ew59HqRWjPe0zZO)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/197914161.png' style="max-width:80%; max-height=80%;"></img></p>

### Java
13、[JPlag](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/jplag/JPlag)：Open Source Code Plagiarism Detection Tool. This is a tool for detecting source code similarity, supporting multiple programming languages such as Java, C/C++, Python, and JavaScript, which is suitable for identifying plagiarism in programming assignments and other scenarios.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/32648170.png' style="max-width:80%; max-height=80%;"></img></p>

14、[MooTool](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/rememberber/MooTool)：Cross-platform Developer Toolbox. This is a desktop application developed with Java for developers' frequently used tools, supporting Windows, macOS, and Linux systems. It provides developers with a variety of practical tools, such as text conversion, time handling, JSON formatting, and regular expression matching testing.Shared by [@周波](https://hellogithub.com/en/user/0UhXFJvP9ndHtiB)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/214978063.png' style="max-width:80%; max-height=80%;"></img></p>

### JavaScript
15、[paint-board](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/LHRUN/paint-board)：Simple and Easy-to-Use Web-based Creative Drawing Board. This is a web-based drawing board application that supports mobile devices, integrating a variety of creative brushes and painting features. It supports operations such as shape drawing, erasing, customizing the drawing board, and saving works as images.Shared by [@Leo Song](https://hellogithub.com/en/user/T1MwoAkuxOfqarN)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/534574923.png' style="max-width:80%; max-height=80%;"></img></p>

16、[PptxGenJS](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/gitbrent/PptxGenJS)：JavaScript Library for Creating Presentation Slides (PPT). This is a JavaScript library for generating PPT files that is easy to get started with, powerful, and supports the addition of charts, tables, SVGs, GIFs, and other content. The generated files are compatible with applications such as PowerPoint and Keynote.Shared by [@Fenix](https://hellogithub.com/en/user/4dzVMWGUfYLPpak)
```typescript
import pptxgen from "pptxgenjs";

// 1. Create a new Presentation
let pres = new pptxgen();

// 2. Add a Slide
let slide = pres.addSlide();

// 3. Add one or more objects (Tables, Shapes, Images, Text and Media) to the Slide
let textboxText = "Hello World from PptxGenJS!";
let textboxOpts = { x: 1, y: 1, color: "363636" };
slide.addText(textboxText, textboxOpts);

// 4. Save the Presentation
pres.writeFile();
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/52322425.png' style="max-width:80%; max-height=80%;"></img></p>

17、[Reactive-Resume](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/AmruthPillai/Reactive-Resume)：Free and Open-Source Resume Design Platform. This is a free, open-source, and ad-free online resume creation platform that comes with 12 professional resume templates, supports multiple languages, PDF export, and OpenAI integration.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/249995750.jpg' style="max-width:80%; max-height=80%;"></img></p>

18、[vue-xiuxiangame](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/setube/vue-xiuxiangame)：Open Source Cultivation Text Adventure Game. This is a cultivation simulator developed based on Vue.js, an interactive text game suitable for players who enjoy idle games and cultivation themes.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/828462853.png' style="max-width:80%; max-height=80%;"></img></p>

19、[xyflow](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/xyflow/xyflow)：Powerful and Flexible Flowchart Engine. This project is designed for building node-based editors and interactive diagrams, supporting React and Svelte frameworks. It is ready to use out of the box and highly customizable, suitable for developing workflows and flowcharts among other scenarios.Shared by [@塔咖](https://hellogithub.com/en/user/bzJpGyu0IanC6L7)
```typescript
const initialNodes = [
{ id: '1', position: { x: 0, y: 0 }, data: { label: '1' } },
{ id: '2', position: { x: 0, y: 100 }, data: { label: '2' } },
];

const initialEdges = [{ id: 'e1-2', source: '1', target: '2' }];

function Flow() {
const [nodes, setNodes, onNodesChange] = useNodesState(initialNodes);
const [edges, setEdges, onEdgesChange] = useEdgesState(initialEdges);

const onConnect = useCallback((params) => setEdges((eds) => addEdge(params, eds)), [setEdges]);

return (
  <ReactFlow
    nodes={nodes}
    edges={edges}
    onNodesChange={onNodesChange}
    onEdgesChange={onEdgesChange}
    onConnect={onConnect}
  >
    <MiniMap />
    <Controls />
    <Background />
  </ReactFlow>
);
}
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/197018189.png' style="max-width:80%; max-height=80%;"></img></p>

### Kotlin
20、[Android-DataBackup](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/XayahSuSuSu/Android-DataBackup)：Android Data Backup Application. This project offers backup and recovery features for app data on systems running Android 7.0 and above, addressing issues like the need to re-login or download additional data packs when switching devices.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/430540203.jpg' style="max-width:80%; max-height=80%;"></img></p>

21、[BinaryEye](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/markusfisch/BinaryEye)：Android Barcode Scanning Application. This is a simple and easy-to-use, ad-free Android barcode and QR code scanner that supports rapid recognition of a variety of barcode and QR code types, and provides QR code/barcode generation capabilities.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/101552674.png' style="max-width:80%; max-height=80%;"></img></p>

### PHP
22、[cachet](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/cachethq/cachet)：Service Status Monitoring Page Built with PHP. This project is a service status monitoring and management platform built using Laravel+Bootstrap, which is free and open-source. It not only automatically monitors the uptime of services but also provides a management backend for actively recording and maintaining incident information, with support for multiple languages, self-hosting, mobile adaptation, and email notifications.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/26730195.png' style="max-width:80%; max-height=80%;"></img></p>

23、[minimalist-web-notepad](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/pereorga/minimalist-web-notepad)：Ultra-Simple Online Notepad App. This project is a web notepad tool written in PHP, with its core functionalities implemented through just one file. It offers online editing, automatic saving, and note sharing capabilities. Users can utilize the app without the need to register or log in, making it suitable for scenarios where temporary notes, quick saves, and text sharing are required.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/5299409.png' style="max-width:80%; max-height=80%;"></img></p>

### Python
24、[Box](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/cdgriffith/Box)：Advanced Dictionary Manipulation Library for Python. This is a Python library that enhances the usability of dictionaries, which is compatible with native dictionaries. It supports dot notation (dict.user.name) for easy access and assignment of values, and can automatically create missing keys to avoid KeyError exceptions.Shared by [@Bit0rls1Mc](https://hellogithub.com/en/user/F7PCYiI3d9WBfpZ)
```python
from box import Box

hg_box = Box({ "HelloGitHub": { "star": "89k", "fork": "9.5k" } })
hg_box.HelloGitHub.star
# 89k
hg_box.to_json(filename="hg.json")
new_box = Box.from_json(filename="hg.json")
new_box.keys()
# dict_keys(['HelloGitHub'])
```

25、[Game-Cheats-Manager](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/dyang886/Game-Cheats-Manager)：Game Modifier Management Tool. This is a powerful game modifier management tool that supports functionalities such as searching, downloading, launching, importing, and updating game modifiers.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/737509032.png' style="max-width:80%; max-height=80%;"></img></p>

26、[linkding](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/sissbruecker/linkding)：Minimalist Bookmark Management Platform for Browsers. This project is a browser bookmark management platform built with Django, offering a clean and user-friendly web interface along with robust search capabilities. It supports tag-based categorization, batch editing, and reading it later functionalities. Additionally, it comes with Chrome and Firefox extensions, making it convenient for users to save and access bookmarks anytime, anywhere.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/194212327.png' style="max-width:80%; max-height=80%;"></img></p>

27、[mkdocs-material](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/squidfunk/mkdocs-material)：Quickly Generate a Material-Style Documentation Site. This project is an aesthetically pleasing and feature-rich documentation site generator built on MkDocs, supporting Markdown, search, mobile adaptation, multilingualism, and other functions. It is suitable for quickly creating technical documentation, product manuals, and tutorial-style websites.Shared by [@猎隼丶止戈reNo7](https://hellogithub.com/en/user/Ew59HqRWjPe0zZO)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/50617428.png' style="max-width:80%; max-height=80%;"></img></p>

28、[SeleniumBase](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/seleniumbase/SeleniumBase)：Comprehensive Browser Automation Framework. This project is a Python automation testing framework based on Selenium, integrating multiple functionalities such as web crawling, automated testing, and report generation. It provides a wealth of examples and a unique UC (User-Centric) model to help developers avoid detection when performing browser automation operations.
```python
from seleniumbase import BaseCase
BaseCase.main(__name__, __file__)

class TestSimpleLogin(BaseCase):
    def test_simple_login(self):
        self.open("seleniumbase.io/simple/login")
        self.type("#username", "demo_user")
        self.type("#password", "secret_pass")
        self.click('a:contains("Sign in")')
        self.assert_exact_text("Welcome!", "h1")
        self.assert_element("img#image1")
        self.highlight("#image1")
        self.click_link("Sign out")
        self.assert_text("signed out", "#top_message")
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/17420614.gif' style="max-width:80%; max-height=80%;"></img></p>

### Rust
29、[abstreet](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/a-b-street/abstreet)：Open Source Urban Traffic Simulator. This is an urban traffic simulation tool written in Rust, supporting the simulation of various modes of transportation, including private cars, public transportation, walking, and cycling. Users can simulate different traffic strategies and infrastructure adjustments within the software.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/135952436.gif' style="max-width:80%; max-height=80%;"></img></p>

30、[delta](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/dandavison/delta)：Command Line Tool to Enhance Git Difference Readability. This is a command line tool written in Rust that presents Git's diff, blame, and grep commands in a clearer and more aesthetically pleasing manner. It supports features like line numbering, syntax highlighting, and smarter inline difference display, seamlessly integrating into the Git workflow.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/193526915.png' style="max-width:80%; max-height=80%;"></img></p>

31、[dust](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/bootandy/dust)：A Command-line Tool for Quick Display of Disk Usage. This is a command-line tool for visualizing disk usage, with a name derived from a combination of 'du' and the Rust programming language. It is compact, fast, and can display an intuitive overview of disk space.Shared by [@DeShuiYu](https://hellogithub.com/en/user/ZWJkOqsvYbPgD8p)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/125563061.png' style="max-width:80%; max-height=80%;"></img></p>

32、[stalwart](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/stalwartlabs/stalwart)：Secure and Easily Deployable Email Service. This project is an email server written in Rust, supporting common email protocols such as SMTP, IMAP, and POP3, with built-in powerful spam and phishing site filters.Shared by [@Mauro D.](https://hellogithub.com/en/user/ogvJ1bR2hPjHkVy)

### Swift
33、[Pearcleaner](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/alienator88/Pearcleaner)：Free Mac Application Cleaning Tool. This is a free and open-source Mac application cleaning tool capable of completely uninstalling applications and cleaning up residual files. Developed with SwiftUI, it provides a simple and user-friendly interface, supporting features such as right-click uninstallation, mini mode, and Homebrew cleanup.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/717960955.png' style="max-width:80%; max-height=80%;"></img></p>

### AI
34、[k8sgpt](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/k8sgpt-ai/k8sgpt)：Kubernetes Troubleshooting AI Assistant. This project utilizes Large Language Models (LLM) to automatically analyze issues in Kubernetes clusters and provide troubleshooting and optimization suggestions. It generates reliable diagnostic reports by reading the cluster's status data and configurations.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/617152691.gif' style="max-width:80%; max-height=80%;"></img></p>

35、[llama_index](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/run-llama/llama_index)：Data Framework for Large Language Models. This project is a data framework designed specifically for Large Language Model (LLM) applications, helping developers easily integrate private data with LLMs. It offers data connectors that support the creation of indexes from various data sources such as APIs, PDFs, documents, and SQL databases, simplifying the data import and query operations to the point where beginners can enhance the context of LLMs with just a few lines of code.
```python
from llama_index.core import VectorStoreIndex, SimpleDirectoryReader

documents = SimpleDirectoryReader("data").load_data()
index = VectorStoreIndex.from_documents(documents)
query_engine = index.as_query_engine()
response = query_engine.query("Some question about the data should go here")
print(response)
```

36、[RAG_Techniques](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/NirDiamant/RAG_Techniques)：Retrieval-Augmented Generation (RAG) Tutorial Collection. This project offers more than 20 advanced tutorials on RAG techniques, including implementation guides and sample codes, with regular updates. It covers a variety of RAG technologies such as retrieval query, context augmentation, fusion retrieval, hierarchical indexing, context compression, and knowledge graph integration.

37、[video2x](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/k4yt3x/video2x)：Lossless Video and Image Upscaling Tool. This project integrates various super-resolution algorithms (such as Waifu2x, Anime4K, and Real-ESRGAN), effectively enhancing the resolution of videos and images, and offers usage methods like Graphical User Interface (GUI), Docker, and Command Line Interface (CLI).

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/122758193.png' style="max-width:80%; max-height=80%;"></img></p>

### Other
38、[deskreen](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/pavlobu/deskreen)：A Tool to Turn Any Device into a Second Screen for Your Computer. This project leverages WebRTC technology to mirror the computer screen to the screen of a device with a web browser via WiFi, implementing screen sharing functionality, thus making it an auxiliary display for the computer.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/286047827.jpg' style="max-width:80%; max-height=80%;"></img></p>

39、[Kazumi](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Predidit/Kazumi)：Cross-Platform Anime Tracking Masterpiece. This is an anime collection app developed using Flutter, where users can collect, track, search for, and watch anime online by customizing Xpath rules. It supports features such as subtitles, danmaku (barrage), timetables, hardware acceleration, and wireless screen projection, and is suitable for various platforms including Android, Windows, and macOS.Shared by [@Micro·J](https://hellogithub.com/en/user/L2Xx0OfvPzpYt4u)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/798049841.png' style="max-width:80%; max-height=80%;"></img></p>

40、[open-and-shut](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/veggiedefender/open-and-shut)：New Usage for Notebook Lids. This is a tool that inputs Morse code by repeatedly closing and opening a laptop's lid.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/251081242.gif' style="max-width:80%; max-height=80%;"></img></p>

41、[rime-ice](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/iDvel/rime-ice)：Out-of-the-box RIME Input Method Configuration. This is a configuration file for the RIME input method, which requires the RIME client for use. It provides a high-quality, long-maintained Simplified Chinese lexicon and optimizes the English typing experience.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/334110599.png' style="max-width:80%; max-height=80%;"></img></p>

42、[vCards](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/metowolf/vCards)：Open Source Electronic Business Card File. This project collects and organizes the numbers and avatars of frequently contacted individuals, optimizing the experience of incoming call and contact information interfaces, supporting both subscription (automatic updates) and manual import of VCF files.Shared by [@Mingo](https://hellogithub.com/en/user/auVvsjDMeyQW7nc)

43、[Watchy](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/sqfmi/Watchy)：Open Source E-Ink Smart Watch. This project is a smart watch made using ESP32-PICO-D4 and an E-Ink display, which supports calendar, alarm, step count, gesture detection, as well as WiFi and Bluetooth functionalities.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/220497210.png' style="max-width:80%; max-height=80%;"></img></p>

### Book
44、[grammar-club](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/llwslc/grammar-club)：Grammar Club. This is an English grammar book written by teacher Xuan Yuanyou, aimed at helping readers establish a solid foundation in grammar, suitable for English learners of all levels.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/101/190264619.png' style="max-width:80%; max-height=80%;"></img></p>



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub100.md">『Previous』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/899'>Feedback</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub102.md">『Next』</a>
</p>

---
<p align="center">
    👉 <a href='https://hellogithub.com/en/periodical'>Submit open-source project!</a> 👈<br>
</p>

## Sponsor


<table>
  <thead>
    <tr>
      <th align="center" style="width: 80px;">
        <a href="https://www.compshare.cn/?utm_term=logo&utm_campaign=hellogithub&utm_source=otherdsp&utm_medium=display&ytag=logo_hellogithub_otherdsp_display">          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/ucloud.png" width="60px"><br>
          <sub>UCloud</sub><br>
          <sub>超值的GPU云服务</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.upyun.com/?from=hellogithub">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/upyun.png" width="60px"><br>
          <sub>CDN</sub><br>
          <sub>开启全网加速</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://github.com/OpenIMSDK/Open-IM-Server">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/im.png" width="60px"><br>
          <sub>OpenIM</sub><br>
          <sub>开源IM力争No.1</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.qiniu.com/products/ai-token-api?utm_source=hello">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/qiniu.jpg" width="60px"><br>
          <sub>七牛云</sub><br>
          <sub>百万 Token 免费体验</sub>
        </a>
      </th>
    </tr>
  </thead>
</table>


## Disclaimer
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="Creative Commons License" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>
This work is licensed under a <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/">Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License</a>.
