# HelloGitHub Vol.104
> Passion is the best teacher. **HelloGitHub** inspires your interest in open-source!
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/cover.jpg' style="max-width:100%;"></img>
</p>

## Table of Contents

Click the **「Table of Contents」** icon at the top-right corner to open the navigation and enjoy a better reading experience.

![](https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/catalog.png)

## Content
> **The content of this issue is as follows**｜Updated on the **28th** of each month

### C
1、[deskhop](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/hrvach/deskhop)：Dual-Machine Mouse and Keyboard Sharing Solution Based on Raspberry Pi. This is a desktop switching utility for rapidly switching between mouse and keyboard setups, addressing the tediousness and latency issues users face when sharing a keyboard and mouse among multiple computers. It supports seamless input switching between different operating systems (Linux, macOS, Windows) through hardware intermediary devices by dragging the mouse or using shortcut keys. The project is entirely open-source and does not require additional driver installation. The hardware is based on Raspberry Pi Pico and USB input/output protocols, supporting custom configurations and offering various additional features such as slow mouse mode, screen lock, and gaming mode.Shared by [@无间之钟](https://hellogithub.com/en/user/rnlYFdQcyhRm50p)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/735426820.gif' style="max-width:80%; max-height=80%;"></img></p>

2、[kyanos](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/hengyoush/kyanos)：In-Depth Kernel-Level Network Traffic Analysis Tool. This is a network problem analysis tool based on eBPF that can monitor and analyze HTTP, Redis, and MySQL requests in real-time. It supports powerful traffic filtering capabilities, allowing for precise filtering based on process, container, protocol information, and duration, and provides multi-dimensional aggregated packet information, suitable for troubleshooting network performance issues such as slow queries to remote services.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/793985221.gif' style="max-width:80%; max-height=80%;"></img></p>

3、[minisign](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/jedisct1/minisign)：Simple and Easy-to-Use File Signing Tool. This is a ready-to-use digital file signing and verification tool that allows for the generation and verification of file signatures with simple commands. It is based on the Ed25519 public key signature system, providing reliable file integrity verification functionality, suitable for software distribution and file sharing scenarios.
```
# 创建密钥
minisign -G
# 对文件进行签名
minisign -Sm HelloGitHub.txt
# 验证签名
$ minisign -Vm HelloGitHub.txt -P xxxx
```

### C#
4、[AvaloniaVisualBasic6](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/BAndysc/AvaloniaVisualBasic6)：The Classic VB6 IDE Rebirth Project. This project recreates the classic Visual Basic 6 IDE using the C# programming language and the Avalonia framework, supporting the creation, saving, loading, and execution of VB6 language projects, and can run on Windows, macOS, Linux, and browsers.Shared by [@39499740](https://hellogithub.com/en/user/7eRBdwFSrtPxipV)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/884565845.gif' style="max-width:80%; max-height=80%;"></img></p>

5、[FileConverter](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Tichau/FileConverter)：A Convenient Right-Click Tool for File Conversion and Compression. This is a file conversion and compression tool designed specifically for Windows. Users can easily perform file format conversion and compression operations through the right-click menu. It is completely free, open-source, supports a variety of file formats, batch processing, and offers multilingual support, including Chinese.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/33476566.gif' style="max-width:80%; max-height=80%;"></img></p>

### C++
6、[carla](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/carla-simulator/carla)：Open Source Autonomous Driving Research and Development Simulation Platform. This is an open-source simulator for autonomous driving research, specifically designed to provide a virtual environment for the development, training, and validation of autonomous driving systems. It includes a free digital asset library featuring city layouts, building and vehicle models, and supports flexible configuration of sensor suites and environmental conditions. Additionally, it offers an easy-to-use Python API for developers to control vehicles, configure sensors, and adjust environmental parameters.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/108102826.png' style="max-width:80%; max-height=80%;"></img></p>

7、[PrismLauncher](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/PrismLauncher/PrismLauncher)：Open-source Minecraft Launcher. This project is a Minecraft launcher developed based on MultiMC, designed to help users easily manage multiple Minecraft versions and instances. It optimizes the launcher experience, supporting fast switching between different versions, mod configurations, and game settings, and is compatible with Windows, Linux, and macOS platforms.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/553135896.png' style="max-width:80%; max-height=80%;"></img></p>

8、[zeal](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/zealdocs/zeal)：Practical Offline Document Browsing Tool. This project is an offline document query tool inspired by Dash, tailored for developers to access various programming languages and framework API documentations without connecting to the internet. It offers a concise interface, various editor plugins, and supports the creation and import of custom documents, making it suitable for viewing technical documentation in environments without internet access.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/7711472.png' style="max-width:80%; max-height=80%;"></img></p>

### Go
9、[dpanel](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/donknap/dpanel)：Lightweight Docker Visualization Management Panel. This is a Docker visualization management panel designed specifically for domestic users, with a completely Chinese interface. It is easy to install and has low resource consumption, running inside a container without intrusion to the host machine, and supports container management, image management, file management, as well as Compose management features.Shared by [@donknap](https://hellogithub.com/en/user/ekhLfDOxR5U0mVw)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/722655859.png' style="max-width:80%; max-height=80%;"></img></p>

10、[go-blueprint](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Melkeydev/go-blueprint)：A Tool to Quickly Generate Go Web Project Structure. This is a command-line tool designed to rapidly establish Go language Web projects, integrating with popular Go frameworks such as Chi, Gin, Fiber, and Echo. It supports the selection of mainstream databases like MySQL, Postgres, and Redis, and also provides advanced configurations for WebSocket and Docker. Users simply need to choose their technology stack to generate a complete Go Web project structure.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/703404066.png' style="max-width:80%; max-height=80%;"></img></p>

11、[lute](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/88250/lute)：A Markdown Engine More Friendly to Chinese. This is a Markdown engine written in Go, implementing the latest GFM/CM specification. It converts Markdown text into an abstract syntax tree (AST) and features faster parsing without regular expressions. It supports GFM/CM specifications, built-in code highlighting, terminology correction, formatting (automatically inserting spaces between Chinese and English), and Emoji parsing capabilities.Shared by [@两双筷子sqldc](https://hellogithub.com/en/user/5dGtvaZ6H3L4QMY)
```go
func main() {
	luteEngine := lute.New() // 默认已经启用 GFM 支持以及中文语境优化
	html:= luteEngine.MarkdownStr("demo", "**Lute** - A structured markdown engine.")
	fmt.Println(html)
	// <p><strong>Lute</strong> - A structured Markdown engine.</p>
}
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/225160662.png' style="max-width:80%; max-height=80%;"></img></p>

12、[OliveTin](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/OliveTin/OliveTin)：Minimalist Shell Command Web Management Platform. This project offers a simple and intuitive web interface that allows users to quickly execute predefined Shell commands. It is ready to use out of the box, easy to configure, and resource-light, making complex commands as simple as a button on a webpage.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/365300077.png' style="max-width:80%; max-height=80%;"></img></p>

13、[wanderer](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Flomp/wanderer)：Open-source Expedition Tracking and Sharing Platform. This project is a Web platform for recording and managing users' outdoor adventure tracks, helping you save precious journey data. It is developed with Go+Svelte, offering features such as upload, save, view (multiple views), and sharing of adventure tracks, and supports self-hosting.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/749092533.png' style="max-width:80%; max-height=80%;"></img></p>

### JavaScript
14、[moodist](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/remvze/moodist)：Free, High-Aesthetic White Noise Website. This is an auditory website designed to aid concentration and relaxation, entirely free without any need for registration. It features a clean interface and easy operation, with 75 built-in white noise options. Users can freely choose and combine according to their preferences to find a suitable sound environment. Additionally, Moodist supports features like timed shutdown, Pomodoro clock, and shortcut keys.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/700879222.png' style="max-width:80%; max-height=80%;"></img></p>

15、[rot.js](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ondras/rot.js)：JavaScript Toolkit for Developing Roguelike Games. This is a dependency-free JavaScript library designed specifically for developing Roguelike (rouge-like) games, encompassing multiple modules such as map generation, random number generation, pathfinding, key handling, and lighting.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/4391145.png' style="max-width:80%; max-height=80%;"></img></p>

16、[slugify](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/simov/slugify)：JS Library for Transforming Strings to URL-Friendly. This project is designed to convert strings into formats suitable for use in URLs, outputting a string composed of lowercase letters, numbers, and hyphens, without spaces and special characters. This format is beneficial for search engine optimization (SEO).
```javascript
var slugify = require('slugify')

slugify('some string') // some-string

// if you prefer something other than '-' as separator
slugify('some string', '_')  // some_string
```

17、[starlight](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/withastro/starlight)：One-stop Documentation Solution Based on Astro. This project is a documentation theme built on the Astro framework, designed for quickly building and deploying documentation websites. It features a beautiful interface, out-of-the-box functionality, fast access, support for website navigation, search, internationalization, SEO, and various plugins.Shared by [@小小修真者](https://hellogithub.com/en/user/OJpriDKTWlq0ZHI)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/614933136.png' style="max-width:80%; max-height=80%;"></img></p>

18、[xiaoju-survey](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/didi/xiaoju-survey)：Enterprise-level Survey Platform. This is a free and professional research system designed to provide individuals and enterprises with a one-stop product-level survey solution. It has both front-end and back-end open-sourced and supports one-click deployment with Docker. It includes a variety of question types and templates, and supports logical arrangement, custom branding, permission management, data analysis, and export functions. It can be used to create surveys, exams, assessments, and complex forms.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/713210442.png' style="max-width:80%; max-height=80%;"></img></p>

### Kotlin
19、[ab-download-manager](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/amir1376/ab-download-manager)：Kotlin-based Download Utility. This is an open-source desktop download utility designed to offer a convenient and fast downloading experience. It features a modern interface and faster download speeds, supports download queues, speed limits, and browser plugin capabilities, and is compatible with Windows and Linux platforms.Shared by [@DeShuiYu](https://hellogithub.com/en/user/ZWJkOqsvYbPgD8p)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/825187044.png' style="max-width:80%; max-height=80%;"></img></p>

20、[Olauncher](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/tanujnotes/Olauncher)：Minimalist Android Launcher. This is a free, ad-free Android launcher that allows up to 8 apps on the home screen, providing a minimalist Android experience, and supports features such as gestures, double-tap to lock the screen, and daily wallpaper updates.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/278638069.png' style="max-width:80%; max-height=80%;"></img></p>

### Python
21、[ASCII-generator](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/vietnh1009/ASCII-generator)：Python Library for Generating Text Images. This project is a tool for converting images and videos into ASCII art, which artistically expresses image content using characters. It is easy to use, supports the transformation of images into text or ASCII style images, as well as videos into ASCII style videos, and provides multiple features such as color selection.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/168572824.jpg' style="max-width:80%; max-height=80%;"></img></p>

22、[icloud_photos_downloader](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/icloud-photos-downloader/icloud_photos_downloader)：iCloud Photo Download Tool. This is a Python-developed tool for batch downloading iCloud photos. It offers three operational modes: copy, sync, and move, supports Live Photos, automatically deletes duplicate data, incremental downloads, and is suitable for scenarios such as iCloud photo migration and backup.

23、[imagehash](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/JohannesBuchner/imagehash)：Python Library for Identifying Similar Images Based on Hash Values. This project utilizes an algorithm that differs from traditional cryptographic hash functions (such as MD5, SHA-1), as it focuses on analyzing the similarity of image content. It can generate similar hash values for images with slight differences, which is used to calculate image similarity. It supports algorithms like average hashing, perceptual hashing, and differential hashing, making it suitable for quickly identifying copyrighted images and other similar scenarios.
```python
from PIL import Image
import imagehash

# 计算第一个图像的哈希值
hash = imagehash.average_hash(Image.open('tests/data/imagehash.png'))
print(hash)
# 哈希值：ffd7918181c9ffff

# 计算第二个图像的哈希值
otherhash = imagehash.average_hash(Image.open('tests/data/peppers.png'))
print(otherhash)
# 哈希值：9f172786e71f1e00

# 比较两个图像哈希值是否相等
print(hash == otherhash)  # False

# 计算并输出哈希值的汉明距离
print(hash - otherhash)  # 33 汉明距离（差异度）
```

24、[mopidy](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/mopidy/mopidy)：Python-Powered Music Server. This is an easily scalable music server written in Python, supporting the scanning and playback of local music, and integrating multiple online streaming music services. It also allows for expansion of music sources, management interfaces, and online players through plugins.

25、[pyarmor](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/dashingsoft/pyarmor)：Powerful Python Script Encryption Tool. This is a command-line tool for obfuscating Python scripts, with a single command to complete the encryption process. It offers a variety of encryption options to balance security and performance, supporting features such as binding encrypted scripts to specific machines, setting an encryption expiration date, and Themida protection.Shared by [@Xuefeng Xu](https://hellogithub.com/en/user/k4oyT8wSU5Qfx6H)

### Rust
26、[kanata](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/jtroo/kanata)：Cross-Platform Keyboard Remapping Tool. This is a keyboard remapping tool developed in Rust that allows users to customize their keyboard layout and functionality according to their own needs, including features such as click and hold, key combinations programming, and setting key response speed, compatible with Windows, Linux, and macOS systems.

27、[surrealdb](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/surrealdb/surrealdb)：End-to-End Cloud-Native Database. This is a multi-model database developed in Rust, supporting table (Table), document (Documents), and graph (Graph) data models. It can be used as both a database and an API backend service, supporting various query methods such as SQL, GraphQL, ACID transactions, graph queries, and full-text indexing.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/436658287.png' style="max-width:80%; max-height=80%;"></img></p>

28、[tauri](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/tauri-apps/tauri)：Rust-Driven Cross-Platform Desktop Application Development Framework. This is a framework for building smaller, faster, and more secure desktop and mobile applications, supporting platforms like macOS, Windows, Linux, Android, and iOS. It allows for constructing user interfaces with front-end frameworks and includes features such as an app packager, system tray icons, and native notifications.Shared by [@DeShuiYu](https://hellogithub.com/en/user/ZWJkOqsvYbPgD8p)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/196701619.png' style="max-width:80%; max-height=80%;"></img></p>

### Swift
29、[Off-Day](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/zizicici/Off-Day)：iOS app for Alarms Not Ringing on Rest Days. This is an iOS-specific holiday alarm application that includes several public holiday templates, allowing users to easily mark holidays and automatically manage alarm settings for workdays and holidays, ensuring that rest days are not disturbed by alarms.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/794390400.png' style="max-width:80%; max-height=80%;"></img></p>

### AI
30、[krita-ai-diffusion](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Acly/krita-ai-diffusion)：Krita's AI Art Assistant Plugin. This is an AIGC plugin developed specifically for the Krita drawing software, designed to offer a more convenient and controllable image generation experience. Users simply need to select an area and input a text prompt to easily achieve operations such as image filling, expansion, enlargement, object addition, and deletion, with support for local operation, Stable Diffusion, ControlNet, IP-Adapter, and custom checkpoints.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/686161611.png' style="max-width:80%; max-height=80%;"></img></p>

31、[netron](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/lutzroeder/netron)：Cross-platform Machine Learning Model Viewer. This is a visualization tool for neural networks, deep learning, and machine learning models, supporting various model formats including ONNX, TensorFlow Lite, Core ML, Keras, Caffe, Darknet, and PyTorch.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/1198539.png' style="max-width:80%; max-height=80%;"></img></p>

32、[Perplexica](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ItzCrazyKns/Perplexica)：AI-Powered Search Engine Tool. This is an open-source AI search engine tool inspired by Perplexity AI. It combines technologies such as SearxNG and Large Language Models (LLMs) to understand your queries and search the internet for answers, serving as an alternative to traditional search engines.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/784181462.png' style="max-width:80%; max-height=80%;"></img></p>

33、[TensorRT-YOLO](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/laugh12321/TensorRT-YOLO)：Flexible and Easy-to-Use YOLO Deployment Tool. This is a YOLO deployment tool optimized specifically for NVIDIA devices. By integrating TensorRT plugins and CUDA technology, it offers C++ and Python APIs, significantly enhancing inference speed and ease of use. It supports multiple versions of YOLO, suitable for various scenarios such as object detection, instance segmentation, pose recognition, rotated object detection, and video analysis.Shared by [@Laugh](https://hellogithub.com/en/user/2AGzE4dsO8ZUD9R)
```python
import cv2
from tensorrt_yolo.infer import DeployDet, generate_labels_with_colors, visualize

# 初始化模型
model = DeployDet("yolo11n-with-plugin.engine")
# 加载图片
im = cv2.imread("test_image.jpg")
# 模型预测
result = model.predict(cv2.cvtColor(im, cv2.COLOR_BGR2RGB))
print(f"==> detect result: {result}")
# 可视化
labels = generate_labels_with_colors("labels.txt")
vis_im = visualize(im, result, labels)
cv2.imwrite("vis_image.jpg", vis_im)
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/749292767.gif' style="max-width:80%; max-height=80%;"></img></p>

### Other
34、[BewlyBewly](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/BewlyBewly/BewlyBewly)：Browser Extension to Optimize the Bilibili Website Interface. This is a third-party Bilibili browser extension that enhances the user experience by optimizing the bilibili website interface, and supports Chrome, Edge, and Firefox browsers.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/473632745.png' style="max-width:80%; max-height=80%;"></img></p>

35、[frpc-desktop](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/luckjiawei/frpc-desktop)：Cross-platform frp Desktop Client. This project is a desktop client for the intranet penetration tool frp, making it more convenient to achieve intranet penetration. It is ready to use out of the box, has a clean interface, supports boot-up startup, multiple users, and configuration import and export functions, and is suitable for Windows, Linux, and macOS platforms.Shared by [@蠢🐷](https://hellogithub.com/en/user/fRmIN16g9jXtYFe)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/723986046.png' style="max-width:80%; max-height=80%;"></img></p>

36、[keeptrack.space](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/thkruz/keeptrack.space)：Satellite Data 3D Visualization Tool. This is an open-source celestial mechanics tool developed for non-professionals, supporting functions such as viewing satellite data, simulating satellite launches, and break-ups, and is suitable for educational and popular science scenarios.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/77081817.png' style="max-width:80%; max-height=80%;"></img></p>

37、[openhaystack](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/seemoo-lab/openhaystack)：Framework for Item Tracking Using Apple's Network. This project leverages Apple's Find My network to achieve cross-device location tracking. By transforming Bluetooth-capable devices into AirTag-like trackers, it allows for easy location pinpointing of personal items, facilitating their retrieval.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/341208122.jpg' style="max-width:80%; max-height=80%;"></img></p>

38、[ping-clock](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/turingbirds/ping-clock)：A Clock Displaying Network Latency. This is a homemade clock designed to display the response time of the ping command, with an overall cost of approximately 150 euros.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/284364418.gif' style="max-width:80%; max-height=80%;"></img></p>

39、[spotube](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/KRTirtho/spotube)：Open Source Spotify Client. This project is a Spotify client developed using Flutter, completely free and ad-free. It uses Spotify, JioSaavn, and YouTube as music sources, allowing users to freely download music without logging in, and supports both desktop and mobile devices.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/104/338719962.png' style="max-width:80%; max-height=80%;"></img></p>

### Book
40、[copenhagen](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/pilcrowonpaper/copenhagen)：A Guide to Implementing Authentication in Web Applications. This book introduces how to implement authentication (auth) in Web applications, covering guidance and suggestions on designing authentication processes, storing user credentials, and protecting user data.

41、[php-the-right-way](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/codeguy/php-the-right-way)：PHP: The Right Way. This is an intermediate PHP book suitable for beginners, introducing best practices and coding standards of PHP, which has been translated into multiple languages including Chinese.



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub103.md">『Previous』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/899'>Feedback</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub105.md">『Next』</a>
</p>

---
<p align="center">
    👉 <a href='https://hellogithub.com/en/periodical'>Submit open-source project!</a> 👈<br>
</p>

## Sponsor


<table>
  <thead>
    <tr>
      <th align="center" style="width: 80px;">
        <a href="https://www.compshare.cn/?utm_term=logo&utm_campaign=hellogithub&utm_source=otherdsp&utm_medium=display&ytag=logo_hellogithub_otherdsp_display">          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/ucloud.png" width="60px"><br>
          <sub>UCloud</sub><br>
          <sub>超值的GPU云服务</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.upyun.com/?from=hellogithub">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/upyun.png" width="60px"><br>
          <sub>CDN</sub><br>
          <sub>开启全网加速</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://github.com/OpenIMSDK/Open-IM-Server">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/im.png" width="60px"><br>
          <sub>OpenIM</sub><br>
          <sub>开源IM力争No.1</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.qiniu.com/products/ai-token-api?utm_source=hello">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/qiniu.jpg" width="60px"><br>
          <sub>七牛云</sub><br>
          <sub>百万 Token 免费体验</sub>
        </a>
      </th>
    </tr>
  </thead>
</table>


## Disclaimer
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="Creative Commons License" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>
This work is licensed under a <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/">Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License</a>.
