# HelloGitHub Vol.107
> Passion is the best teacher. **HelloGitHub** inspires your interest in open-source!
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/cover.jpg' style="max-width:100%;"></img>
</p>

## Table of Contents

Click the **「Table of Contents」** icon at the top-right corner to open the navigation and enjoy a better reading experience.

![](https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/catalog.png)

## Content
> **The content of this issue is as follows**｜Updated on the **28th** of each month

### C
1、[earlyoom](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/rfjakob/earlyoom)：Linux Daemon to Prevent OOM. This is an OOM (Out of Memory) daemon specifically designed for Linux to compensate for the deficiency of the kernel's built-in OOM Killer, which only triggers when memory runs out. It intervenes sooner (by default 10%), automatically terminating the process that consumes the most memory, thus preventing the system from becoming frozen due to memory exhaustion.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/15850784.png' style="max-width:80%; max-height=80%;"></img></p>

2、[sqlite-vec](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/asg017/sqlite-vec)：SQLite Vector Search Extension. This is a lightweight, zero-dependency vector search SQLite extension that adds the ability to insert and query floating-point, integer, and binary vectors into SQLite databases. It can run on any platform that supports SQLite, including Linux, macOS, Windows, browsers (WASM), Raspberry Pi, and more.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/789538509.png' style="max-width:80%; max-height=80%;"></img></p>

### C#
3、[Flyby11](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/builtbybel/Flyby11)：Windows 11 Upgrade Assistant. This is an open-source Windows 11 upgrade assistant tool. It can help users bypass hardware restrictions to install the latest version of Windows 11 on unsupported old devices.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/875403491.png' style="max-width:80%; max-height=80%;"></img></p>

4、[ImageGlass](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/d2phap/ImageGlass)：A Clean Windows Image Viewer. This is a feature-rich image viewing tool focused on providing a smooth image browsing experience for Windows users. It boasts a clean and intuitive interface, supports over 80 image formats and multiple languages, as well as practical image editing features such as lossless compression and resizing.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/7377936.png' style="max-width:80%; max-height=80%;"></img></p>

5、[MahApps.Metro](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/MahApps/MahApps.Metro)：Elegant WPF UI Framework. This project is a UI framework specifically designed for WPF applications, aiming to assist developers in swiftly constructing modern and elegant desktop user interfaces. It includes a rich array of controls, icons, themes, and convenient Visual Studio templates.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/2584777.gif' style="max-width:80%; max-height=80%;"></img></p>

### C++
6、[champ](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/chvmp/champ)：Open-Source Quadruped Robot Control Development Framework. This is an open-source development framework for quadruped robots, suitable for building quadruped robots and developing control algorithms. It provides lightweight header file libraries and a rich set of ROS tool packages, supporting full autonomous navigation, Gazebo simulation environments, and a variety of hardware platforms, offering developers a complete quadruped robot control framework and development tools.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/186157988.gif' style="max-width:80%; max-height=80%;"></img></p>

7、[cling](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/root-project/cling)：Interactive C++ Development Environment. This is an interactive C++ interpreter built based on LLVM and Clang. It provides an intuitive interactive command-line interface, supporting the immediate writing, execution, and debugging of C++ code, and can be integrated with Jupyter.Shared by [@chenxu](https://hellogithub.com/en/user/2szDRMLtYI9bVcT)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/49210203.png' style="max-width:80%; max-height=80%;"></img></p>

8、[MusicPlayer2](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/zhongyang219/MusicPlayer2)：Versatile Windows Music Player. This project is a minimalist, compact, and versatile Windows local music player written in C++, supporting common audio formats, and providing features such as lyric display, karaoke mode, lyric editing, album cover display, spectrum analysis, and sound effect adjustments.Shared by [@wyf9](https://hellogithub.com/en/user/WoGJ1ZiVstBkyAb)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/99799314.gif' style="max-width:80%; max-height=80%;"></img></p>

### Go
9、[codeforces-go](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/EndlessCheng/codeforces-go)：Algorithm Competition Template in Go Language. This project, created by Lingcha Mountain Aifu, is an algorithm competition template based on the Go programming language. It provides a comprehensive and systematic set of algorithm templates covering various fields from basic data structures to advanced algorithms.

10、[goja](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/dop251/goja)：Go Language Implementation of a JavaScript Engine. This project is a high-performance JavaScript engine implemented entirely in Go, allowing developers to easily execute JavaScript code within the Go environment. It supports running compilers written in ES5 such as Babel and TypeScript, and is compatible with most ES6 features.
```go
vm := goja.New()
v, err := vm.RunString("2 + 2")
if err != nil {
    panic(err)
}
if num := v.Export().(int64); num != 4 {
    panic(num)
}
```

11、[ipatool](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/majd/ipatool)：A Tool for Easily Downloading IPA Files. This is a command-line tool that can help users search for and download .ipa files in the iOS App Store, supporting Windows, Linux, and macOS platforms.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/369755856.gif' style="max-width:80%; max-height=80%;"></img></p>

12、[pspy](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/DominicBreuker/pspy)：Tool for Real-time Monitoring of Linux Processes Without Root Permissions. This is a tool that can monitor all user commands, scheduled tasks, and other process activities on Linux systems in real-time without requiring root permissions. It collects process information by traversing /proc and listening for file system events, capable of real-time detection of newly started and short-lived processes, suitable for scenarios such as CTF competitions, penetration testing, and security auditing.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/120821432.gif' style="max-width:80%; max-height=80%;"></img></p>

13、[wego](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/schachmat/wego)：A Command-line Tool for Quick Weather Forecasts. This is a weather checking tool developed using Go language, which helps users quickly obtain weather information for the coming days, including temperature, wind speed, wind direction, precipitation, and more.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/26971815.gif' style="max-width:80%; max-height=80%;"></img></p>

### Java
14、[logisim-evolution](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/logisim-evolution/logisim-evolution)：Open-source Digital Circuit Design and Simulation Software. This is a digital logic circuit design and simulation tool developed in Java, suitable for educational and development scenarios. It offers an intuitive interface, supports real-time simulation of circuit behavior, signal timing diagrams, hardware integration, VHDL, common components, and multi-language support.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/24217298.png' style="max-width:80%; max-height=80%;"></img></p>

15、[synthea](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/synthetichealth/synthea)：Open Source Tool for Simulating Patient Populations. This is an open-source simulator for synthetic patient data and health records, capable of generating various medical information data including medical records, symptoms, diagnoses, medications, and vaccination records. It is suitable for clinical research, epidemiological studies, and other similar scenarios.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/61399845.png' style="max-width:80%; max-height=80%;"></img></p>

### JavaScript
16、[canvas-confetti](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/catdad/canvas-confetti)：JavaScript Library for Confetti Animation Effects. This is a lightweight, high-performance confetti animation library that allows you to easily add cool dynamic effects to your web pages. It uses HTML5 Canvas technology for animation rendering, supports various parameters such as particle quantity, emission angle, speed, gravity, and color, as well as custom shape and text animations, making it suitable for scenarios like holiday celebrations and game reward effects.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/119001901.gif' style="max-width:80%; max-height=80%;"></img></p>

17、[color-thief](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/lokesh/color-thief)：JavaScript Library for Extracting Color Palettes from Images. This is a JavaScript library that easily obtains the main colors or color combinations of an image, suitable for scenarios where dynamic extraction of image colors is needed.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/2688455.png' style="max-width:80%; max-height=80%;"></img></p>

18、[newsnow](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ourongxing/newsnow)：Fully Open-Source Real-Time News Platform. This is a high-aesthetic real-time news and hotlist website that focuses more on real-time news compared to traditional hotlist products. It is completely open-source for both frontend and backend, easy to deploy, and can be easily hosted on platforms like Cloudflare Pages or Vercel.Shared by [@Ou](https://hellogithub.com/en/user/SMJiFwlsKCkWf89)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/861790708.png' style="max-width:80%; max-height=80%;"></img></p>

19、[soybean-admin](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/soybeanjs/soybean-admin)：Elegant Vue3 Management Dashboard Template.This project is a management dashboard template built with a technology stack including Vue3, Vite5, Pinia, and UnoCSS. It features not only an aesthetically pleasing interface but also a clear project structure, strict type checking, unified coding standards, embedded rich theme configurations, internationalization solutions, page components, and mobile support.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/404414397.png' style="max-width:80%; max-height=80%;"></img></p>

20、[web-check](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Lissy93/web-check)：Comprehensive Website Inspection Tool.This is a web inspection tool that can display more information about a specified website. For example: DNS records, server location, site performance, SSL certificates, performance, SEO, and other information, which can be used for analyzing the server architecture of a website, checking for security vulnerabilities, and other scenarios.Shared by [@Zhiqiang Li](https://hellogithub.com/en/user/GeVAyPh1pJOSaWN)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/658364446.png' style="max-width:80%; max-height=80%;"></img></p>

### Kotlin
21、[Pluvia](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/oxters168/Pluvia)：Unofficial Steam Client on Android. This is a lightweight, unofficial Steam client designed for Android. It allows users to browse, download, and run DRM-free Steam games on mobile devices, supporting features such as Steam Cloud Saves and friend lists.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/868277149.gif' style="max-width:80%; max-height=80%;"></img></p>

### Python
22、[input-remapper](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/sezanzeb/input-remapper)：A Tool to Easily Change Key Behavior for Linux Users. This project is a tool specifically designed for the Linux operating system, capable of easily altering the behavior of input devices. It supports a variety of input devices including keyboards, mice, game controllers, and joysticks.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/307515577.png' style="max-width:80%; max-height=80%;"></img></p>

23、[kitty](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/kovidgoyal/kitty)：GPU-Accelerated Terminal Emulator. This is a cross-platform terminal emulator based on GPU acceleration, designed to provide developers with a smooth command-line operation experience. It significantly improves rendering speed using OpenGL rendering technology, faster than traditional terminals, and supports custom fonts, multi-window, multi-tab, and high-resolution display features.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/71056775.png' style="max-width:80%; max-height=80%;"></img></p>

24、[manga-image-translator](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/zyddnys/manga-image-translator)：A Tool for One-Click Translation of Text in Images. This is a Python project designed to recognize and translate text within images, supporting multiple languages such as Japanese, Chinese, English, and Korean. It is suitable for translating the text content in comics and illustrations.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/339920287.png' style="max-width:80%; max-height=80%;"></img></p>

25、[piku](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/piku/piku)：Minimalist PaaS Tool. This is a lightweight Platform as a Service (PaaS) tool that allows users to deploy their applications to servers with just a simple git push command. It consists of only 1500 lines of Python code, runs on devices with low specifications such as Raspberry Pi, and supports multiple programming languages including Python, Node.js, and Java. Additionally, it offers multi-application deployment and free SSL certificate functionalities.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/54778964.gif' style="max-width:80%; max-height=80%;"></img></p>

26、[posting](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/darrenburns/posting)：Cool Terminal API Debugger. This is a modern terminal HTTP client, which can be considered as the command-line version of Postman and Insomnia. It provides developers with a convenient TUI experience, optimizes keyboard operation processes, supports auto-completion, syntax highlighting, Vim key binding, and storing requests locally in YAML files.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/806285077.png' style="max-width:80%; max-height=80%;"></img></p>

### Rust
27、[neovide](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/neovide/neovide)：Rust-crafted Neovim Client. This is a cross-platform desktop client designed for the Neovim editor (a refactored version of Vim). It retains the core functionalities of Nvim while providing a modern graphical interface for a more friendly user experience.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/226408450.png' style="max-width:80%; max-height=80%;"></img></p>

28、[Nping](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/hanshuaikang/Nping)：Rust Multi-Address Concurrent Ping Tool.This is a visualized Ping tool developed in Rust, supporting concurrent Ping operations on multiple target addresses. It provides visual displays such as partitioned line charts and table views, supports real-time dynamic display of performance metrics like latency and packet loss rate, and is compatible with both IPv4 and IPv6 network environments.Shared by [@韩数](https://hellogithub.com/en/user/uT2Sc8Xli4PUA76)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/906665483.gif' style="max-width:80%; max-height=80%;"></img></p>

29、[simple-http-server](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/TheWaWaR/simple-http-server)：Rust Lightweight HTTP(s) Server. This project is a lightweight HTTP(s) server written in Rust, which provides simple and easy static file service quickly. It has the characteristics of being out-of-the-box and cross-platform, supporting HTTPS, authentication, CORS configuration, file upload, and other features.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/92592878.png' style="max-width:80%; max-height=80%;"></img></p>

### Swift
30、[Cork](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/buresdv/Cork)：Homebrew GUI Management Tool. This project is a graphical user interface (GUI) designed specifically for Homebrew, aiming to simplify the use of Homebrew through a graphical interface, allowing users to more easily install, update, and uninstall software packages.Shared by [@Micro·J](https://hellogithub.com/en/user/L2Xx0OfvPzpYt4u)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/510067764.png' style="max-width:80%; max-height=80%;"></img></p>

31、[periphery](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/peripheryapp/periphery)：Open Source Swift Code 'Cleaner'. This project is a tool for detecting and cleaning unused code in Swift projects. It supports integration with build systems such as Xcode, SwiftPM, and Bazel, and provides flexible configuration options to help developers efficiently clean up redundant code and optimize project quality.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/169972846.png' style="max-width:80%; max-height=80%;"></img></p>

### AI
32、[ai-by-hand-excel](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ImagineAILab/ai-by-hand-excel)：Handcrafting Various AI Algorithms and Models with Excel. This project implements and demonstrates the core algorithms and concepts of artificial intelligence and deep learning using Excel, allowing beginners to operate and understand the principles of AI, including matrix multiplication, MLP, RNN, Transformer, ResNet, etc., in a unique and easy-to-understand form, reducing the threshold for learning AI.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/857733465.png' style="max-width:80%; max-height=80%;"></img></p>

33、[AstrBot](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/AstrBotDevs/AstrBot)：Easy-to-Use Multi-platform LLM Chatbot. This project is an LLM chatbot and development framework built with Python, supporting integration with various messaging platforms and large language models. It offers a visual management panel and a flexible plugin extension mechanism, with features like rate limiting, whitelists, keyword filtering, image understanding, and speech-to-text.Shared by [@大痴小乙zt2kV](https://hellogithub.com/en/user/wg8ucRq0Lb75zTy)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/575865240.png' style="max-width:80%; max-height=80%;"></img></p>

34、[cognita](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/truefoundry/cognita)：Open-source Low-code RAG Platform. This is an RAG platform built based on LangChain and LlamaIndex, supporting one-click Docker deployment. It features an easy-to-use web interface that offers data upload, model management, internet connectivity, and prompt template functionalities, allowing users to effortlessly build, debug, and publish RAG applications without writing any code.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/671064065.gif' style="max-width:80%; max-height=80%;"></img></p>

35、[lm-evaluation-harness](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/EleutherAI/lm-evaluation-harness)：Open Source LLM Evaluation Framework. This framework is designed to evaluate Large Language Models (LLMs), capable of testing model performance across various tasks. It offers over 60 academic benchmarks, supports multiple model frameworks, local models, cloud services (like OpenAI), hardware acceleration, and the capability to customize tasks.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/290909192.png' style="max-width:80%; max-height=80%;"></img></p>

36、[watermark-removal](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/zuruoke/watermark-removal)：AI Tool for Removing Image Watermarks. This is an open-source image restoration tool based on TensorFlow that can remove watermarks from images with just one command.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/424507010.jpg' style="max-width:80%; max-height=80%;"></img></p>

### Other
37、[ESP-Drone](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Circuit-Digest/ESP-Drone)：Low-Cost Open-Source Drone. This is an open-source drone project based on the ESP32, which helps you to create a low-cost, smartphone-controllable small drone.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/689881351.gif' style="max-width:80%; max-height=80%;"></img></p>

38、[hexo-theme-A4](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/HiNinoJay/hexo-theme-A4)：Parchment Style Hexo Blog Theme. This is a simple Hexo blog theme designed to be as minimalistic as an A4 sheet of paper, allowing readers to focus on reading and authors to concentrate on writing.Shared by [@nino](https://hellogithub.com/en/user/ePZoMD50CdrK7f1)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/627803190.png' style="max-width:80%; max-height=80%;"></img></p>

39、[LazyCat-Bookmark-Cleaner](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Alanrk/LazyCat-Bookmark-Cleaner)：A tool for one-click browser bookmark organization. This is an open-source browser bookmark management plugin that helps you easily organize your browser bookmarks. It does not require an internet connection and protects your privacy. It supports both Chinese and English, automatically detects invalid bookmarks, duplicate bookmarks, and empty folders, and can also generate a bookmark usage report.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/909670009.png' style="max-width:80%; max-height=80%;"></img></p>

40、[linuxpdf](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ading2210/linuxpdf)：Linux System Running Inside a PDF File. This project embeds a Linux system into a PDF file, powered by the RISC-V simulator TinyEMU. Users can open the PDF file in a browser, initiate the Linux system, and interact with it.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/916802481.png' style="max-width:80%; max-height=80%;"></img></p>

41、[moodiary](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ZhuJHua/moodiary)：An Open-source Cross-platform Diary App Built with Flutter. This is a fully open-source diary software that is aesthetically pleasing. It supports various text editing formats and multimedia attachments, along with features like password protection, biometric unlock, footprint map, smart assistant, synchronization, and backup capabilities, and is compatible with systems like Android, iOS, Windows, macOS, and Linux.Shared by [@云烨](https://hellogithub.com/en/user/XECVTG0rFmk15L8)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/846895415.png' style="max-width:80%; max-height=80%;"></img></p>

42、[Xiaomi-BootLoader-Questionnaire](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/MlgmXyysd/Xiaomi-BootLoader-Questionnaire)：Answer Test for Xiaomi Mobile Unlock and Flashing Qualification. This project is a question bank for unlocking Xiaomi BootLoader. The reason is that before obtaining the qualification to unlock BootLoader on Xiaomi mobile phones, users must first pass a series of questions to apply.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/726300407.png' style="max-width:80%; max-height=80%;"></img></p>

### Book
43、[ai-self-coding-book](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/easychen/ai-self-coding-book)：Sugar Cube AI Self-Programming Introduction. This book is an AI self-programming introductory tutorial written by the author based on practical experience. It aims to help non-programmers leverage AI to develop complex and high-quality programs, not limited to toy programs like Snake.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img4/master/hellogithub/107/917240200.jpg' style="max-width:80%; max-height=80%;"></img></p>



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub106.md">『Previous』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/899'>Feedback</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub108.md">『Next』</a>
</p>

---
<p align="center">
    👉 <a href='https://hellogithub.com/en/periodical'>Submit open-source project!</a> 👈<br>
</p>

## Sponsor


<table>
  <thead>
    <tr>
      <th align="center" style="width: 80px;">
        <a href="https://www.compshare.cn/?utm_term=logo&utm_campaign=hellogithub&utm_source=otherdsp&utm_medium=display&ytag=logo_hellogithub_otherdsp_display">          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/ucloud.png" width="60px"><br>
          <sub>UCloud</sub><br>
          <sub>超值的GPU云服务</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.upyun.com/?from=hellogithub">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/upyun.png" width="60px"><br>
          <sub>CDN</sub><br>
          <sub>开启全网加速</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://github.com/OpenIMSDK/Open-IM-Server">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/im.png" width="60px"><br>
          <sub>OpenIM</sub><br>
          <sub>开源IM力争No.1</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.qiniu.com/products/ai-token-api?utm_source=hello">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/qiniu.jpg" width="60px"><br>
          <sub>七牛云</sub><br>
          <sub>百万 Token 免费体验</sub>
        </a>
      </th>
    </tr>
  </thead>
</table>


## Disclaimer
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="Creative Commons License" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>
This work is licensed under a <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/">Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License</a>.
