# HelloGitHub Vol.89
> Passion is the best teacher. **HelloGitHub** inspires your interest in open-source!
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/cover.jpg' style="max-width:100%;"></img>
</p>

## Table of Contents

Click the **「Table of Contents」** icon at the top-right corner to open the navigation and enjoy a better reading experience.

![](https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/catalog.png)

## Content
> **The content of this issue is as follows**｜Updated on the **28th** of each month

### C
1、[barco](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/lucavallin/barco)：Write a Linux Container from Scratch in C. This project relies solely on the fundamental Linux features and implements a Linux container using the C language, which can be used to learn more about the technical details of Linux containers and the kernel.
```
$ sudo ./bin/barco -u 0 -m / -c /bin/sh -a . [-v]

22:08:41 INFO  ./src/barco.c:96: initializing socket pair...
22:08:41 INFO  ./src/barco.c:103: setting socket flags...
22:08:41 INFO  ./src/barco.c:112: initializing container stack...
22:08:41 INFO  ./src/barco.c:120: initializing container...
22:08:41 INFO  ./src/barco.c:131: initializing cgroups...
22:08:41 INFO  ./src/cgroups.c:73: setting memory.max to 1G...
22:08:41 INFO  ./src/cgroups.c:73: setting cpu.weight to 256...
22:08:41 INFO  ./src/cgroups.c:73: setting pids.max to 64...
22:08:41 INFO  ./src/cgroups.c:73: setting cgroup.procs to 1458...
22:08:41 INFO  ./src/barco.c:139: configuring user namespace...
22:08:41 INFO  ./src/barco.c:147: waiting for container to exit...
22:08:41 INFO  ./src/container.c:43: ### BARCONTAINER STARTING - type 'exit' to quit ###

# ls
bin         home                lib32       media       root        sys         vmlinuz
boot        initrd.img          lib64       mnt         run         tmp         vmlinuz.old
dev         initrd.img.old      libx32      opt         sbin        usr
etc         lib                 lost+found  proc        srv         var
# echo "i am a container"
i am a container
```

2、[quake2-rerelease-dll](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/id-Software/quake2-rerelease-dll)：Quake II Official Remastered Source Code. Quake II, released by id Software in 1997, is considered a classic first-person shooter by many players. This project is the official source code of Quake II re-released in 2023.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/675738701.jpg' style="max-width:80%; max-height=80%;"></img></p>

3、[trurl](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/curl/trurl)：Command Line Tool for Parsing and Manipulating URLs. This project is a new work by the author of cURL, and can be used to parse URLs, replace/extract/set parameters in the URLs.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/621725724.jpg' style="max-width:80%; max-height=80%;"></img></p>

### C#
4、[GeekDesk](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/BookerLiu/GeekDesk)：Compact Windows Desktop Launcher Tool. This free tool named Geek Desktop features a minimalistic interface and supports full disk file search, one-click activation, custom wallpaper, and scheduled reminders, amongst other functionalities.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/357072316.gif' style="max-width:80%; max-height=80%;"></img></p>

5、[Starward](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Scighost/Starward)：An Open Source miHoYo Game Launcher. This is a launcher that supports all miHoYo desktop games, including downloading games, tracking game time, switching accounts, saving gacha records, and offering Mihoyo community tool kits. It can run on Windows 10 and above operating systems.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/636565625.gif' style="max-width:80%; max-height=80%;"></img></p>

### C++
6、[implot](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/epezent/implot)：Real-time Drawing GUI Library. This project is a Dear ImGui drawing library that updates the image in real-time based on user interaction and data updates, supporting GPU acceleration, various drawing types, and mixed drawing capabilities. With just a few lines of code, you can integrate the functionality of real-time data visualization.
```
int   bar_data[11] = ...;
float x_data[1000] = ...;
float y_data[1000] = ...;

ImGui::Begin("My Window");
if (ImPlot::BeginPlot("My Plot")) {
    ImPlot::PlotBars("My Bar Plot", bar_data, 11);
    ImPlot::PlotLine("My Line Plot", x_data, y_data, 1000);
    ...
    ImPlot::EndPlot();
}
ImGui::End();
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/257596449.gif' style="max-width:80%; max-height=80%;"></img></p>

7、[wslg](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/microsoft/wslg)：Tool for Running Linux Graphical Applications on Windows. This project is an open-source tool by Microsoft that supports running Linux GUI applications on the Windows operating system. It offers a native and natural Linux GUI application experience, including functions such as cross-cutting and pasting between Windows and Linux applications. WSLg is built into systems Windows 10 and above, and can be launched directly via the wsl command.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/346871538.png' style="max-width:80%; max-height=80%;"></img></p>

### Go
8、[etree](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/beevik/etree)：A More User-Friendly Lightweight Go Language XML Library. Although the Go language includes a built-in library for handling XML, it can be cumbersome to define structures according to the nesting levels when using it. This project is inspired by Python's ElementTree library, which allows for flexible reading and generation of XML documents without the need to define structures.Shared by [@两双筷子sqldc](https://hellogithub.com/en/user/5dGtvaZ6H3L4QMY)
```go
doc := etree.NewDocument()
doc.CreateProcInst("xml", `version="1.0" encoding="UTF-8"`)
doc.CreateProcInst("xml-stylesheet", `type="text/xsl" href="style.xsl"`)

people := doc.CreateElement("People")
people.CreateComment("These are all known people")

jon := people.CreateElement("Person")
jon.CreateAttr("name", "Jon")

sally := people.CreateElement("Person")
sally.CreateAttr("name", "Sally")

doc.Indent(2)
doc.WriteTo(os.Stdout)
```

9、[golang-design-pattern](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/senghoo/golang-design-pattern)：Go Language Design Pattern Example Code. This project is the author's notes from reading the book 'Grounding Design Patterns', and has implemented the 23 design patterns mentioned in the book using the Go language.

10、[ls-lint](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/loeffel-io/ls-lint)：Tool for Checking Directory and File Naming Styles. This is a Lint tool for directories and filenames written in Go. It has few dependencies and is fast, allowing for custom detection rules and ignored directories through a yml configuration file, suitable for various scenarios such as Git Hooks, GitHub Action, and Docker Image.
```
ls:
  .js: snake_case
  .ts: snake_case | camelCase
  .d.ts: PascalCase
  .html: regex:[a-z0-9]+

ignore:
  - node_modules
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/240896563.gif' style="max-width:80%; max-height=80%;"></img></p>

11、[webp_server_go](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/webp-sh/webp_server_go)：A Plug-and-Play WebP Server. WebP is an image format developed by Google to improve the speed of image loading. This project is a WebP server written in Go, which can transform images in formats such as JPG, PNG, BMP, SVG, etc., into the WebP format without the need for further development, effectively reducing the file size, saving bandwidth, and improving the speed of image loading.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/239239351.png' style="max-width:80%; max-height=80%;"></img></p>

### Java
12、[Jailer](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Wisser/Jailer)：A Powerful Database Data Extraction Tool. A tool for browsing database subsets and relational data, supporting browsing of databases according to inter-table relationships, and generating DML topological relationships, among other features. It can be used to extract the necessary database tables and data from a production database to support the testing of a complete business line.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/1923665.png' style="max-width:80%; max-height=80%;"></img></p>

13、[OneAccount](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/LouBii/OneAccount)：A Minimalist Android Accounting App. This is an accounting app for Android that supports custom spending/income categories, timely reminders, budget settings, and expense statistics features.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/148282280.jpg' style="max-width:80%; max-height=80%;"></img></p>

14、[triplea](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/triplea-game/triplea)：A Java-based Turn-based War Game. This is a free, open-source war chess game where players can simulate classic battles such as World War II and the Napoleonic Wars within the game, supporting Windows, Linux, and macOS operating systems.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/39766308.png' style="max-width:80%; max-height=80%;"></img></p>

### JavaScript
15、[biomes-game](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ill-inc/biomes-game)：An Open-Source Sandbox MMORPG Game. This is a large-scale multiplayer online role-playing game (MMORPG) developed by the Global Illumination company, which has been acquired by OpenAI. Utilizing technologies such as React, Next.js, TypeScript, and WebAssembly, the game offers players the ability to explore the world, build houses, trade, and socialize within the game world. It is browser-based and requires no download to play.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/677467268.gif' style="max-width:80%; max-height=80%;"></img></p>

16、[docsify](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/docsifyjs/docsify)：Out-of-the-Box Documentation Website Generator. This project helps you quickly generate a documentation website that is ready to use without the need for building. You can publish it immediately after writing your documents. It supports full-text search, customizable themes, a rich set of APIs, Emoji, and other practical features.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/74260508.png' style="max-width:80%; max-height=80%;"></img></p>

17、[poster-design](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/palxiao/poster-design)：A Powerful Online Graphic Design Tool. An online poster and graphic design tool developed using Vue3, Vite2, Vuex, and ElementPlus technologies, which can be used to generate e-commerce share images, article long images, video/public account covers, etc.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/454264265.gif' style="max-width:80%; max-height=80%;"></img></p>

18、[warriorjs](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/olistic/warriorjs)：Engaging JavaScript Programming RPG Game. In this game, you will command the warriors to fight against the enemies and rescue the captives by using JavaScript syntax, step by step moving towards the top of the tower to obtain the legendary JavaScript Sword.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/34798315.gif' style="max-width:80%; max-height=80%;"></img></p>

19、[WeHalo](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/sav7ng/WeHalo)：Refreshing WeChat Mini Program Version of a Blog. This project is a WeChat mini program based on the Halo blog backend, which allows you to easily transfer blog content to the WeChat mini program. It supports features such as personal business cards, blog post display, comments, article search, and custom navigation bar.Shared by [@umail.com](https://hellogithub.com/en/user/a0L3Omilqk8zNQY)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/158522838.png' style="max-width:80%; max-height=80%;"></img></p>

### Python
20、[DrissionPage](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/g1879/DrissionPage)：A Web Automation Tool Similar to Selenium. This is a Python-based web automation tool that supports Chromium-based browsers. It combines the functionalities of controlling the browser and sending/receiving requests into one unified interface with a consistent and concise API.Shared by [@马小六](https://hellogithub.com/en/user/MdXgAyzJSFbTeHh)
```python
# 下载星巴克产品图
from DrissionPage import SessionPage
from re import search

# 以s模式创建页面对象
page = SessionPage()
# 访问目标网页
page.get('https://www.starbucks.com.cn/menu/')

# 获取所有class属性为preview circle的元素
divs = page.eles('.preview circle')
# 遍历这些元素
for div in divs:
    # 用相对定位获取当前div元素后一个兄弟元素，并获取其文本
    name = div.next().text

    # 在div元素的style属性中提取图片网址并进行拼接
    img_url = div.attr('style')
    img_url = search(r'"(.*)"', img_url).group(1)
    img_url = f'https://www.starbucks.com.cn{img_url}'

    # 执行下载
    page.download(img_url, r'.\imgs', rename=name)
```

21、[learndb-py](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/spandanb/learndb-py)：Build a Database from Scratch Using Python. This project aims to implement a relational database from scratch using Python, providing a better understanding of the internal structure of data. This database is intended for learning and practice, and should not be used in production environments.

22、[nvitop](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/XuehaiPan/nvitop)：NVIDIA GPU Process Monitoring Tool Similar to the 'top' Command. This is a monitoring tool for NVIDIA devices and processes, featuring a colorful interface with real-time updates on processes and device information, supporting process filtering, mouse control, signaling, and other functionalities.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/332736941.png' style="max-width:80%; max-height=80%;"></img></p>

23、[upiano](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/eliasdorneles/upiano)：E-Piano Running in the Command Line. This is a small command line application of an electronic piano that is easy to install and convenient to run, supporting both mouse and keyboard operation modes.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/98796916.png' style="max-width:80%; max-height=80%;"></img></p>

24、[watchgha](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/nedbat/watchgha)：Tool to view GitHub Action run status locally. A command-line tool that displays the running status of GitHub Actions for the current branch with just one command.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/613355435.gif' style="max-width:80%; max-height=80%;"></img></p>

### Ruby
25、[OpenFarm](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/openfarmcc/OpenFarm)：A Website Teaching You How to Grow Crops. This is a knowledge base about crop cultivation, where you can find steps on how to grow plants like tomatoes, potatoes, strawberries, etc., and all of this is free of charge.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/13895958.png' style="max-width:80%; max-height=80%;"></img></p>

### Rust
26、[rjvm](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/andreabergia/rjvm)：A Miniature JVM Learning Project Written in Rust. This is a hands-on project written in Rust to replicate a JVM7. It has implemented a set of features including Java basic types, exception handling, stack trace, garbage collection, and parsing of .class files.

27、[starship](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/starship/starship)：Lightweight, Super Fast and Good-looking Terminal. This is a terminal written in Rust, with a high level of aesthetics and compatible with various shells. It comes out of the box, customizable with various prompts, and is suitable for Windows, Linux, Android, and macOS systems.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/178991158.gif' style="max-width:80%; max-height=80%;"></img></p>

### Swift
28、[Mist](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ninxsoft/Mist)：Automated macOS Firmware Downloader. This tool can list all available macOS firmware/installer information, including name, version number, release date, and size.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/509050256.png' style="max-width:80%; max-height=80%;"></img></p>

29、[SkeletonView](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Juanpe/SkeletonView)：An Elegant Swift Skeleton Screen Library. A skeleton screen is a technique that displays the approximate structure of a page when the data required has not yet completed loading. This Swift skeleton screen library is easy to get started with, has a user-friendly interface, and supports all UIView, custom animations, and other features.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/109878485.gif' style="max-width:80%; max-height=80%;"></img></p>

### AI
30、[audiocraft](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/facebookresearch/audiocraft)：Meta's Open Source Text-to-Music Library. This project can generate high-quality and high-fidelity audio and music based on text prompts, such as whistling in the wind or a pop dance tune suitable for a beach scene, with a very impressive generation effect.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/650945129.png' style="max-width:80%; max-height=80%;"></img></p>

31、[Fooocus](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/lllyasviel/Fooocus)：A Plug-and-Play Image Generation Software. This project incorporates the strengths of Stable Diffusion and Midjourney in its design. It is simple to install and easy to operate, eliminating the need for complex parameter adjustments. Users can generate images comparable to Midjourney by simply entering prompt words. Supports local deployment and offline use, with the minimum configuration requirement being 8GB of memory and a 4GB Nvidia graphics card.Shared by [@刘三非](https://hellogithub.com/en/user/VhrXCAs7cMxL08W)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/676676006.png' style="max-width:80%; max-height=80%;"></img></p>

32、[machine-learning-notes](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/roboticcam/machine-learning-notes)：Xu Yida's Machine Learning Course. This project is a collection of open-source lecture notes and video course links on machine learning, probabilistic models, and deep learning provided by Professor Xu Yida from Hong Kong Baptist University (HKBU).

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/121647248.jpg' style="max-width:80%; max-height=80%;"></img></p>

### Other
33、[beepy](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/beeper/beepy)：A Portable Linux Computer with a Full Keyboard. This is a board that combines a BlackBerry keyboard, a 400*200 LCD display, and a 2000mAh battery, priced at $79. By plugging in a Raspberry Pi Zero W, it instantly becomes a BlackBerry version of a Linux playground.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/532730834.jpg' style="max-width:80%; max-height=80%;"></img></p>

34、[cloc](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/AlDanial/cloc)：Tool for Counting Lines of Code. This is a tool that can count the number of whitespace lines, comments, and lines of code in different programming languages within the source code.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/42029482.png' style="max-width:80%; max-height=80%;"></img></p>

35、[How-To-Secure-A-Linux-Server](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/imthenachoman/How-To-Secure-A-Linux-Server)：A Linux Server Security Guide. This is a guide focused on securing Linux servers in non-enterprise scenarios. Although not professional, it is sufficient for personal use.

36、[linux-tutorial](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/dunwu/linux-tutorial)：A Practical Linux Tutorial. Unlike comprehensive Linux tutorials, this project focuses on practicality, covering common Linux commands, system maintenance, software maintenance, and frequently used shell scripts.Shared by [@孤胆枪手](https://hellogithub.com/en/user/i1wAIyo6P3NXkxm)

37、[weekly](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ljinkai/weekly)：Independent Developer Product Monetization Weekly. A weekly publication covering subjects related to independent developers and product monetization.

### Book
38、[lean-side-bussiness](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/easychen/lean-side-bussiness)：Lean Side Project: How Programmers Can Gracefully Engage in Side Projects. This book expands on the content of 'How Programmers Can Earn Pocket Money Gracefully', introduces the lean startup process, optimizes it specifically for lean side project processes, and adds practical content on independent development monetization and online course monetization.

39、[putting-the-you-in-cpu](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/hackclub/putting-the-you-in-cpu)：What Happens When You Run a Program?. This is a mini-book about how a program runs, covering computer basics, operating systems, and how Linux loads executable files.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/648351143.png' style="max-width:80%; max-height=80%;"></img></p>

40、[theByteBook](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/isno/theByteBook)：In-Depth Architecture Principles and Practices. With the rise of cloud computing, the focus of technical architecture has also evolved from cluster availability management to cloud-native and FinOps cost management. The book covers topics such as networking, containers, gateways, microservices and distribution, cloud-native, quality monitoring, and cost management, helping readers quickly grasp the technical architecture system in the cloud era.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/89/547677901.jpg' style="max-width:80%; max-height=80%;"></img></p>

41、[typescript-tutorial](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/wangdoc/typescript-tutorial)：Ruan Yifeng's TypeScript Tutorial. This is a beginner-friendly open-source tutorial for TypeScript, covering the basic concepts and usage of TypeScript.



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub88.md">『Previous』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/899'>Feedback</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub90.md">『Next』</a>
</p>

---
<p align="center">
    👉 <a href='https://hellogithub.com/en/periodical'>Submit open-source project!</a> 👈<br>
</p>

## Sponsor


<table>
  <thead>
    <tr>
      <th align="center" style="width: 80px;">
        <a href="https://www.compshare.cn/?utm_term=logo&utm_campaign=hellogithub&utm_source=otherdsp&utm_medium=display&ytag=logo_hellogithub_otherdsp_display">          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/ucloud.png" width="60px"><br>
          <sub>UCloud</sub><br>
          <sub>超值的GPU云服务</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.upyun.com/?from=hellogithub">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/upyun.png" width="60px"><br>
          <sub>CDN</sub><br>
          <sub>开启全网加速</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://github.com/OpenIMSDK/Open-IM-Server">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/im.png" width="60px"><br>
          <sub>OpenIM</sub><br>
          <sub>开源IM力争No.1</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.qiniu.com/products/ai-token-api?utm_source=hello">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/qiniu.jpg" width="60px"><br>
          <sub>七牛云</sub><br>
          <sub>百万 Token 免费体验</sub>
        </a>
      </th>
    </tr>
  </thead>
</table>


## Disclaimer
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="Creative Commons License" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>
This work is licensed under a <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/">Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License</a>.
