# HelloGitHub Vol.90
> Passion is the best teacher. **HelloGitHub** inspires your interest in open-source!
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/cover.jpg' style="max-width:100%;"></img>
</p>

## Table of Contents

Click the **「Table of Contents」** icon at the top-right corner to open the navigation and enjoy a better reading experience.

![](https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/catalog.png)

## Content
> **The content of this issue is as follows**｜Updated on the **28th** of each month

### C
1、[BlackHole](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ExistentialAudio/BlackHole)：Virtual Audio Driver for macOS. Students who have recorded videos on macOS have likely encountered the problem of recording computer sounds, which requires a high standard of environment when using the public play method. This project is a virtual audio driver for macOS that can pass the output audio to other applications with zero delay, thereby being unaffected by the surrounding environment, and easily recording the sound of the computer. It supports both Intel and Apple chips.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/211381291.png' style="max-width:80%; max-height=80%;"></img></p>

2、[c4](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/rswier/c4)：C Language Compiler Implemented with 4 Functions. This project achieves a compact C language compiler with only over 500 lines of code and 4 functions. However, due to its streamlined code, the source itself is not easy to read.

### C#
3、[optimizer](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/hellzerg/optimizer)：Superbly Useful Windows Optimizer. This is a powerful Windows system optimization tool, featuring a compact size and rich functions. It supports 22 languages, including Chinese, and enables you to disable unnecessary Windows services, delete superfluous startup programs, and shut off unused features, thereby enhancing the usability and performance of the Windows system.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/103370157.png' style="max-width:80%; max-height=80%;"></img></p>

4、[Translumo](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Danily07/Translumo)：Free and Open-Source Real-time Screen Translation Tool. This project is capable of translating text displayed within a selected area on the screen in real-time, recognizing languages such as English, Russian, and Chinese. Users can choose from various OCR engines such as Tesseract, WindowsOCR, and EasyOCR, as well as translation sources including Google Translate.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/654569590.gif' style="max-width:80%; max-height=80%;"></img></p>

### C++
5、[duckdb](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/duckdb/duckdb)：An Analytics Database Similar to SQLite. This project is a lightweight analytical database written in C++, which is compact in size, free from external dependencies, and does not operate as a separate process, akin to an analytical version of SQLite. DuckDB offers a rich SQL dialect, supporting features such as JOIN, aggregation, window functions, and direct querying of CSV and JSON files. Although it does not have a performance advantage in terms of scale, it is fully capable of handling data analysis at the billion-level scale, focusing on being small, light, and sufficient.
```
SELECT * FROM 'HelloGitHub.csv';
SELECT * FROM 'HelloGitHub.parquet';
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/138754790.png' style="max-width:80%; max-height=80%;"></img></p>

6、[kakoune](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/mawww/kakoune)：A Code Editor Similar to Vim. This code editor features a minimalist interface and efficient editing model, inspired by Vim in design but surpassing it in functionality and interactivity. It offers faster and more convenient operation, and comes with default support for features like syntax highlighting and auto-completion, making it suitable for Linux and macOS operating systems.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/2701888.gif' style="max-width:80%; max-height=80%;"></img></p>

7、[SafeLine](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/chaitin/SafeLine)：A Simple and Effective Web Application Firewall. This project is based on the Nginx web gateway at its core, acting as a reverse proxy for network traffic. It employs intelligent semantic analysis algorithms to filter out malicious traffic from hackers, safeguarding your website from hacking attacks. The installation is straightforward, and the free version offers sufficient functionality, although the project only open-sourced the core algorithms and underlying engine.Shared by [@孤胆枪手](https://hellogithub.com/en/user/i1wAIyo6P3NXkxm)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/626896474.png' style="max-width:80%; max-height=80%;"></img></p>

8、[smartknob](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/scottbez1/smartknob)：DIY a Haptic Smart Rotary Knob. This is an open-source smart knob device with customizable end point positions, virtual braking, haptic feedback, and a circular LCD display, making it very cool and fun to interact with.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/420580521.gif' style="max-width:80%; max-height=80%;"></img></p>

9、[typesense](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/typesense/typesense)：A Lightning-fast Open Source Search Engine. This project is an instant search engine written in C++, featuring out-of-the-box usability, rapid search speed, automatic spelling correction, geographical search capabilities, and built-in support for Chinese tokenization.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/79317191.png' style="max-width:80%; max-height=80%;"></img></p>

### CSS
10、[pokemon-cards-css](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/simeydotme/pokemon-cards-css)：Cool Pokémon Card CSS Effects. This project is a collection of advanced CSS styles for Pokémon cards, employing techniques such as 3D transformations, filters, and gradients to achieve effects like luster, texture, galaxy holographic, and vertical light beams.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/505538251.gif' style="max-width:80%; max-height=80%;"></img></p>

### Go
11、[asynq](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/hibiken/asynq)：A Simple and Reliable Distributed Task Queue Written Purely in Go. This is a lightweight asynchronous task queue based on Redis, which launches a goroutine for each task, supporting features such as task failure retries, priority queues, scheduled tasks, and unique tasks.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/221849341.jpg' style="max-width:80%; max-height=80%;"></img></p>

12、[carbon](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/dromara/carbon)：A Go Time Handling Library Friendly to Developers. This is a comprehensive and easy-to-use Go time library that supports time conversions, time differences, time travel, zodiac signs, seasons, lunar calendar, and multilingual features.
```go
lang := carbon.NewLanguage()
lang.SetLocale("zh-CN")

c := carbon.SetLanguage(lang)
if c.Error != nil {
	// 错误处理
	log.Fatal(err)
}

c.Now().AddHours(1).DiffForHumans() // 1 小时后
c.Now().AddHours(1).ToMonthString() // 八月
c.Now().AddHours(1).ToShortMonthString() // 8月
c.Now().AddHours(1).ToWeekString() // 星期二
c.Now().AddHours(1).ToShortWeekString() // 周二
c.Now().AddHours(1).Constellation() // 狮子座
c.Now().AddHours(1).Season() // 夏季
```

13、[nezha](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/nezhahq/nezha)：Domestic Lightweight Server Monitoring Tool. This is a server monitoring panel called 'Nezha', which is easy to install and ready to use out of the box. It supports monitoring the system status of multiple servers, SSL certificate status, alarm notifications, traffic monitoring, setting scheduled tasks, and other features. It is suitable for mainstream operating systems such as Linux, Windows, macOS, and OpenWRT.Shared by [@两双筷子sqldc](https://hellogithub.com/en/user/5dGtvaZ6H3L4QMY)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/220588935.jpg' style="max-width:80%; max-height=80%;"></img></p>

14、[sonyflake](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/sony/sonyflake)：Distributed ID Generation Library in Go Language. This project is a distributed unique ID generator open-sourced by Sony, inspired by the well-known Twitter Snowflake algorithm. It is slower than Snowflake but has a longer lifespan and can work on more machines, making it suitable for larger distributed clusters.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/36485077.png' style="max-width:80%; max-height=80%;"></img></p>

### Java
15、[Algorithms](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/williamfiset/Algorithms)：A Collection of Algorithms and Data Structures Implemented in Java. The importance of algorithms and data structures goes without saying. This project provides the simplest and most elegant implementations of common data structures and algorithms in Java, making it a good choice for both learning and development.Shared by [@孤胆枪手](https://hellogithub.com/en/user/i1wAIyo6P3NXkxm)

16、[Stirling-PDF](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Stirling-Tools/Stirling-PDF)：A Web Application for Various Operations on PDF Files. This is a powerful and ready-to-use PDF tool that supports splitting/merging files, adding/extracting images, compression, watermarking, and adding/removing passwords. It meets all your needs for PDF files.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/594155488.png' style="max-width:80%; max-height=80%;"></img></p>

### JavaScript
17、[Bangumi](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/czy0729/Bangumi)：A 2D Hobbyist Community Client Similar to Douban. This is a third-party client for the 2D community 'Bangumi' built with React Native. It is free of charge, ad-free, born out of passion, designed specifically for mobile devices, and supports anime progress management, user dynamics, forums, search, ranking, and tagging functions.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/185632238.jpg' style="max-width:80%; max-height=80%;"></img></p>

18、[deprank](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/codemix/deprank)：Find the Most Important Files in a Codebase with PageRank. This project uses the PageRank algorithm and source file dependencies to identify the most heavily depended-upon files in a JavaScript/TypeScript code repository.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/509280936.png' style="max-width:80%; max-height=80%;"></img></p>

19、[json-server](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/typicode/json-server)：Simulate Interface Data in Just 30 Seconds Without Coding. This is a compact tool for interface simulation that is very easy to use. Just create a JSON file and a single command can quickly start the interface service.
```
# 安装
npm install -g json-server
# 启动
json-server --watch db.json
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/14747598.png' style="max-width:80%; max-height=80%;"></img></p>

20、[mind-map](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/wanglin2/mind-map)：A Convenient Web Mind Mapping Tool. This project includes a JavaScript library for mind mapping that does not rely on any frameworks, as well as a feature-rich online mind mapping application developed with Vue.js + ElementUI that supports local deployment.
```javascript
import MindMap from "simple-mind-map";

const mindMap = new MindMap({
  el: document.getElementById('mindMapContainer'),
  data: {
    "data": {
        "text": "根节点"
    },
    "children": []
  }
});
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/375741607.png' style="max-width:80%; max-height=80%;"></img></p>

21、[yunxiaozhi](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/danbaixi/yunxiaozhi)：An Open Source Campus Academic Affairs Query WeChat Mini Program. This project is an intelligent campus mini program developed by students, supporting functions such as course schedule query, grade query, exam schedule, vacant classroom query, and utilities query.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/307931045.png' style="max-width:80%; max-height=80%;"></img></p>

### Kotlin
22、[gkd](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/gkd-kit/gkd)：Android App for Custom Screen Touch. This project is an automatic click tool based on accessibility features that supports custom or subscription click rules, which can be used to automatically complete operations such as skipping ads, consenting buttons, receiving red packets, etc.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/661957079.png' style="max-width:80%; max-height=80%;"></img></p>

### Python
23、[argos-translate](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/argosopentech/argos-translate)：Open Source Offline Translation Library Written in Python. This project is an offline translation Python library based on the OpenNMT (neural machine translation framework). It does not rely on any third-party translation interfaces and supports translation of over 30 languages, including Chinese.
```python
import argostranslate.package
import argostranslate.translate

from_code = "en"
to_code = "es"

# Download and install Argos Translate package
argostranslate.package.update_package_index()
available_packages = argostranslate.package.get_available_packages()
package_to_install = next(
    filter(
        lambda x: x.from_code == from_code and x.to_code == to_code, available_packages
    )
)
argostranslate.package.install_from_path(package_to_install.download())

# Translate
translatedText = argostranslate.translate.translate("Hello World", from_code, to_code)
print(translatedText)
# '¡Hola Mundo!'
```

24、[mwmbl](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/mwmbl/mwmbl)：An Open Source, Non-Profit Search Engine Written in Python. This is a small, non-profit, ad-free, and privacy-focused search engine constructed with pandas, FastAPI, scikit-learn, and jusText. It features a minimalistic interface, fast search results, and no external factor interference in the search results.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/441849572.gif' style="max-width:80%; max-height=80%;"></img></p>

25、[prettymaps](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/marceloprates/prettymaps)：Python Library for Creating Aesthetically Pleasing Map Posters. This project enables the creation of visually appealing map posters from OpenStreetMap data with simple, customizable color filling.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/344802603.png' style="max-width:80%; max-height=80%;"></img></p>

26、[webdriver_manager](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/SergeyPirogov/webdriver_manager)：Effortlessly Manage WebDriver with This Python Library. Those who frequently write web crawlers have probably encountered the situation where they need to locate the path of WebDriver each time! With this project, the repetitive search for where WebDriver is located will no longer be necessary.
```python
# 之前
from selenium import webdriver
driver = webdriver.Chrome('/home/user/drivers/chromedriver')

# 现在
from selenium import webdriver
from webdriver_manager.chrome import ChromeDriverManager
driver = webdriver.Chrome(ChromeDriverManager().install())
```

27、[youre-the-os](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/plbrault/youre-the-os)：Computer Operating System Simulation Game. This is a web game written in Python where players take on the role of a computer's operating system. The game requires players to manage processes, memory, and I/O events to ensure that processes do not remain idle for too long. If a process waits for too long, it will exit, and if a certain number of processes exit, the computer will restart and the game is over.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/567061540.png' style="max-width:80%; max-height=80%;"></img></p>

### Ruby
28、[docuseal](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/docusealco/docuseal)：Open-Source Online Document Signing Platform. This is an online document signing platform written in Ruby that is out-of-the-box, easy to use, mobile-friendly, supporting the creation of PDF forms by dragging and dropping, online filling and signing, automatic email sending, user management, and more.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/661850205.jpg' style="max-width:80%; max-height=80%;"></img></p>

### Rust
29、[lettura](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/zhanglun/lettura)：Minimalist Open Source RSS Reader. This is a desktop RSS reader developed based on Tauri. It is free, ad-free, and features a refreshing interface, suitable for macOS and Windows operating systems.Shared by [@](https://hellogithub.com/en/user/r4XBVFhiaz3qPlZ)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/299642790.png' style="max-width:80%; max-height=80%;"></img></p>

30、[privaxy](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Barre/privaxy)：Rust-written Tracking and Ad-blocking Tool. This project is based on the man-in-the-middle (MITM) attack principle, establishing bidirectional tunnels between two ends, filtering URL addresses to prevent ad requests, thereby achieving ad interception. It has low memory usage, fast speed, and supports automatic updates of the filtering list, display of statistics, and custom filtering list features.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/490055087.png' style="max-width:80%; max-height=80%;"></img></p>

### Swift
31、[TomatoBar](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/ivoronin/TomatoBar)：Elegant macOS Menu Bar Pomodoro Clock. This is a Pomodoro timer application for macOS that is compact and exquisite, with a simple interface, supporting settings for work and rest intervals, notification sounds, global hotkeys, and more.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/131987490.png' style="max-width:80%; max-height=80%;"></img></p>

32、[XcodesApp](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/XcodesOrg/XcodesApp)：Practical Tool for Xcode Installation and Switching. Xcode is an integrated development environment provided by macOS for developers. This project allows for the easy installation and switching between various versions of Xcode, with the download process expedited using aria2 for increased speed, and the Xcode release data sourced from the official Apple website.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/315822591.png' style="max-width:80%; max-height=80%;"></img></p>

### AI
33、[hcaptcha-challenger](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/QIN2DIM/hcaptcha-challenger)：A Library for Handling hCaptcha With Elegance. This project uses machine learning to handle hCaptcha without reliance on browser plugins or third-party anti-captcha services. It leverages ResNet and YOLOv8 to address classification and detection issues, employing ONNX to package the model, thereby reducing the barrier to entry for users. It allows the code to run on devices without GPUs, and eliminates the need to install dependencies like PyTorch, enabling an elegant approach to dealing with hCaptcha.Shared by [@QIN2DIM](https://hellogithub.com/en/user/Gm0AckPjzrhTHae)
```python
import os
from pathlib import Path

import hcaptcha_challenger as solver

# Init local-side of the ModelHub
solver.install()

# Challenge prompt of binary challenge 
prompt = "diamond bracelet"

# Load challenge images, assuming you've already downloaded them.
label_dir = Path(__file__).parent.joinpath("diamond_bracelet")
images = [label_dir.joinpath(fn).read_bytes() for fn in os.listdir(label_dir)]

def bytedance():
    classifier = solver.BinaryClassifier()
    # type: List[bool | None]
    # IF True --> click image
    # ELIF False --> bypass image
    # ELSE --> Something err  
    if result := classifier.execute(prompt, images):
        for i, name in enumerate(os.listdir(label_dir)):
            print(f"{name} - {result[i]}")

if __name__ == "__main__":
    bytedance()
```

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/459466436.gif' style="max-width:80%; max-height=80%;"></img></p>

34、[jax](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/jax-ml/jax)：Google's High-Performance Scientific Computing Library. This is a Python library for numerical computation that combines Just-In-Time (JIT) compilation, automatic differentiation (Autograd), and a linear algebra compiler (XLA), with a usage pattern similar to NumPy. However, JAX is faster, more memory-efficient, and supports automatic differentiation, automatic vectorization, parallel computing, and more.
```python
from jax import grad
import jax.numpy as jnp

def tanh(x):  # Define a function
  y = jnp.exp(-2.0 * x)
  return (1.0 - y) / (1.0 + y)

grad_tanh = grad(tanh)  # Obtain its gradient function
print(grad_tanh(1.0))   # Evaluate it at x = 1.0
# prints 0.4199743
# 自动求导
print(grad(grad(grad(tanh)))(1.0))
# prints 0.62162673
```

35、[sd-webui-EasyPhoto](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/aigc-apps/sd-webui-EasyPhoto)：Your AI Smart Photo Generator. This is a web user interface (WebUI) plugin for generating AI portraits that can be used to create professional-quality photos, equivalent to a free, locally deployable 'Miracle Duck Camera'.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/684046942.jpg' style="max-width:80%; max-height=80%;"></img></p>

### Other
36、[catppuccin](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/catppuccin/catppuccin)：Highly Recommended Themed Color Schemes. This project is a community-driven collection of color schemes, featuring a rich palette predominantly in warm tones. It is designed for use in editors and IDEs such as VSCode, JetBrains, and Vim, and is also suitable for development libraries, terminals, operating systems, and browsers across various programming languages.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/425134686.png' style="max-width:80%; max-height=80%;"></img></p>

37、[keyviz](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/mulaRahul/keyviz)：A Free Real-time Key and Mouse Input Visualization Software. This project can display mouse and keyboard operations on the screen, allowing viewers to see your key and mouse actions. Suitable for screenshot, video recording, demonstration, and collaboration scenarios, it supports Windows, Linux, and macOS operating systems.

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/516753000.png' style="max-width:80%; max-height=80%;"></img></p>

38、[LearnPrompt](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/LearnPrompt/LearnPrompt)：Free and Open Source AIGC Course. This project is beginner-friendly and easy to learn without AI knowledge. It not only teaches how to use AIGC effectively but also delves into AI-related knowledge, covering topics such as ChatGPT, Runway, Midjourney, Stable Diffusion, and AI digital humans.

39、[python-weekly](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/chinesehuazhou/python-weekly)：Python Trend Weekly. A weekly Python digest curated by 'Pea Flower and Cat', featuring high-quality articles, tutorials, open-source projects, tools, videos, and trending topics related to Python.

40、[TechStack](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/Get-Tech-Stack/TechStack)：Browser Extension to Display the Technologies Used in GitHub Projects. This project is a browser extension that shows the technology stack used in a GitHub repository, helping users quickly understand more information about the project.Shared by [@CorrectRoadH](https://hellogithub.com/en/user/LlcmQNh12ZgD6sW)

<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img3/master/hellogithub/90/677000403.png' style="max-width:80%; max-height=80%;"></img></p>

41、[webgl-fundamentals](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/gfxfundamentals/webgl-fundamentals)：WebGL Tutorial Starting with Basic Theory. This is a series of WebGL tutorials that start from the basics of mathematical knowledge, including a Chinese translation version.

### Book
42、[css-animation-101](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/cssanimation/css-animation-101)：Mastering CSS Animations. This book primarily focuses on the animation techniques within CSS (CSS animation), covering topics such as what is CSS animation, the transition property, creating complex animation effects, and providing a wealth of examples to show you how to apply CSS animations to your projects.

43、[how-to-write-makefile](https://hellogithub.com/en/periodical/statistics/click?target=https://github.com/seisman/how-to-write-makefile)：Write Makefiles with Me. This project is a reformatted PDF version of a series of articles by Chen Hao, which was originally organized from the 'GNU Make Manual'. The author has optimized the layout and highlighted the code, making it more comfortable to read and serve as a tutorial for beginners to get started with Makefiles.



<p align="center">
    <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub89.md">『Previous』</a> | <a href='https://github.com/521xueweihan/HelloGitHub/issues/899'>Feedback</a> | <a href="https://github.com/521xueweihan/HelloGitHub/blob/master/content/en/HelloGitHub91.md">『Next』</a>
</p>

---
<p align="center">
    👉 <a href='https://hellogithub.com/en/periodical'>Submit open-source project!</a> 👈<br>
</p>

## Sponsor


<table>
  <thead>
    <tr>
      <th align="center" style="width: 80px;">
        <a href="https://www.compshare.cn/?utm_term=logo&utm_campaign=hellogithub&utm_source=otherdsp&utm_medium=display&ytag=logo_hellogithub_otherdsp_display">          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/ucloud.png" width="60px"><br>
          <sub>UCloud</sub><br>
          <sub>超值的GPU云服务</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.upyun.com/?from=hellogithub">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/upyun.png" width="60px"><br>
          <sub>CDN</sub><br>
          <sub>开启全网加速</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://github.com/OpenIMSDK/Open-IM-Server">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/im.png" width="60px"><br>
          <sub>OpenIM</sub><br>
          <sub>开源IM力争No.1</sub>
        </a>
      </th>
      <th align="center" style="width: 80px;">
        <a href="https://www.qiniu.com/products/ai-token-api?utm_source=hello">
          <img src="https://raw.githubusercontent.com/521xueweihan/img_logo/master/logo/qiniu.jpg" width="60px"><br>
          <sub>七牛云</sub><br>
          <sub>百万 Token 免费体验</sub>
        </a>
      </th>
    </tr>
  </thead>
</table>


## Disclaimer
<a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/"><img alt="Creative Commons License" style="border-width: 0" src="https://licensebuttons.net/l/by-nc-nd/4.0/88x31.png"></a><br>
This work is licensed under a <a rel="license" href="https://creativecommons.org/licenses/by-nc-nd/4.0/">Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License</a>.
